// -*- C++ -*-
/*!
 * @file  AGVController.cpp
 * @brief ${rtcParam.description}
 * @date $Date$
 *
 * $Id$
 */

#include "AGVController.h"


using std::cerr;
using std::endl;


// Module specification
// <rtc-template block="module_spec">
static const char* agvcontroller_spec[] =
  {
    "implementation_id", "AGVController",
    "type_name",         "AGVController",
    "description",       "${rtcParam.description}",
    "version",           "1.0.0",
    "vendor",            "AISL.TUT",
    "category",          "StateMachineGateway",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "0",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
AGVController::AGVController(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
		m_inputIn("input", m_input),
		m_fromPlannerIn("fromPlanner", m_fromPlanner),
    m_outputOut("output", m_output),
    m_toPlannerOut("toPlanner", m_toPlanner)
    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
AGVController::~AGVController()
{
}



RTC::ReturnCode_t AGVController::onInitialize()
{
	cerr << ">> AGVCtrl::onInitialize()" << endl;

	// Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
	addInPort("input", m_inputIn);
  addInPort("fromPlanner", m_fromPlannerIn);
  
  // Set OutPort buffer
	addOutPort("output", m_outputOut);
	addOutPort("toPlanner", m_toPlannerOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>
	
	cerr << "<< AGVCtrl::onInitialize()" << endl;
  return RTC::RTC_OK;
}


RTC::ReturnCode_t AGVController::onFinalize()
{
	cerr << ">> AGVCtrl::onFinalize()" << endl;
	cerr << "<< AGVCtrl::onFinalize()" << endl;
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t AGVController::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t AGVController::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t AGVController::onActivated(RTC::UniqueId ec_id)
{
	cerr << ">> AGVCtrl::onActivated()" << endl;
	activate();
	cerr << "<< AGVCtrl::onActivated()" << endl;
  return RTC::RTC_OK;
}


RTC::ReturnCode_t AGVController::onDeactivated(RTC::UniqueId ec_id)
{
	cerr << ">> AGVCtrl::onDeactivated()" << endl;
	cerr << "<< AGVCtrl::onDeactivated()" << endl;
  return RTC::RTC_OK;
}


RTC::ReturnCode_t AGVController::onExecute(RTC::UniqueId ec_id)
{
	if( process() )
		return RTC::RTC_ERROR;
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t AGVController::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t AGVController::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t AGVController::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t AGVController::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t AGVController::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void AGVControllerInit(RTC::Manager* manager)
  {
    coil::Properties profile(agvcontroller_spec);
    manager->registerFactory(profile,
                             RTC::Create<AGVController>,
                             RTC::Delete<AGVController>);
  }
  
};


