#include "HiroGateRTCSVC_impl.h"
#include <cmath>
#include <fstream>
#include <string>
#include "../VSCommon/system/misc/misc.h"
#include "hgutil.h"


/*=========================================================
=========================================================*/
CORBA::Long HiroGateServiceSVC_impl::getHandPoseL(
	RTC::Pose3D& pose_l_m_rad)
{
	return getHandPose( svc_ptrs.acsL_if, pose_l_m_rad );
}


CORBA::Long HiroGateServiceSVC_impl::getHandPoseR(
	RTC::Pose3D& pose_r_m_rad)
{
  return getHandPose( svc_ptrs.acsR_if, pose_r_m_rad );
}


/*=========================================================
	getHandPoseL/R()̋ʕ
=========================================================*/
long HiroGateServiceSVC_impl::getHandPose(
	RTC::CorbaConsumer<OpenHRP::ArmControlService> *acs_if,
	RTC::Pose3D& pose_m_rad)
{
	if( CORBA::is_nil( acs_if->getObject() ) )
		return 0x80000000;

	///// v: [Esb`E[̏
	(*acs_if)->getCurrentConfiguration(
		pose_m_rad.position.x, pose_m_rad.position.y, pose_m_rad.position.z,
		pose_m_rad.orientation.r, pose_m_rad.orientation.p, pose_m_rad.orientation.y );

	return 0;
}