#include "HiroGateRTCSVC_impl.h"
#include <cmath>
#include <fstream>
#include <string>
#include "../VSCommon/system/misc/misc.h"


using namespace std;


/*=========================================================
=========================================================*/
CORBA::Long HiroGateServiceSVC_impl::setJointAngles(
	const HiroGateRTC::HiroGateService::JointAngles& angles_rad, 
	CORBA::Double t, CORBA::Boolean wait_for_motion)
{
  if( CORBA::is_nil( svc_ptrs.sqply_if->getObject() ) )
		return 0x80000000;

	OpenHRP::KeyPose pose;

	convertJointAngles2KeyPose( angles_rad, pose );

	CORBA::Double ttm;
	(*svc_ptrs.sqply_if)->setJointAngles( pose, t, ttm );

	if( wait_for_motion )
		(*svc_ptrs.sqply_if)->isEmpty( 0x1F, true );

  return 0;
}


/*---------------------------------------------------------
	setJointAnglesp̃p[^ϊ
---------------------------------------------------------*/
void HiroGateServiceSVC_impl::convertJointAngles2KeyPose(
	const HiroGateRTC::HiroGateService::JointAngles &angles_rad,
	OpenHRP::KeyPose &pose )
{
	pose.length( angles_rad.length() );
	//printf("%d\n", pose.length());
	for( int part_i(0), part_n(angles_rad.length()); part_i < part_n; ++ part_i ) {
#		if 1
		// ǂ sequence< double > Ȃ̂ňsőł
		pose[part_i] = angles_rad[part_i];
#		else
		pose[part_i].length( angles_rad[part_i].length() );
		for( int angle_i(0), angle_n(angles_rad[part_i].length()); angle_i < angle_n; ++ angle_i )
			pose[part_i][angle_i] = angles_rad[part_i][angle_i];
#		endif
		//printf( "convertJointAngles2KeyPose(): %d\n", pose[part_i].length() );
	}
}