#pragma once


#include <rtm/idl/BasicDataTypeSkel.h>
#include <rtm/idl/ExtendedDataTypesSkel.h>
#include "HiroGateRTCStub.h"
	// ʏ킱̏ł́Chgutil.hƓfBNg(HiroGate)̃t@C
	// 荞܂邪CRTCBuilderŐꂽVCvWFNgł́C
	// uǉ̃CN[hfBNgv"."w肳Ă̂ŁC
	// HiroGateRTCStub.h̓vWFNg̍ƃfBNgǂݍ܂D
#include "../rtcutil/rtcutil.h"
#include "../VSCommon/opencv/cvmath/cvmath.h"


namespace hgutil
{


	/*********************************************************
		JointAngles̃CfbNX
	*********************************************************/
	enum joint_angles_idx_t { BH = 0, AR, AL, HR, HL };
	

	/*********************************************************
		eōłx֐߂̍ő呬xp[^
	*********************************************************/
	static double getLimitAngularVelocityDeg( int joint_angles_idx )
	{
		double vlimit;
		switch( joint_angles_idx ) {
			case BH: vlimit = 190.0;	break;	//BH(CHEST_JOINT0)
			case AR: 
			case AL: vlimit = 260.0;	break;	//BH(?ARM_JOINT2)
			case HR: 
			case HL: vlimit = -1;			break;
			default: vlimit = -1;
		}
		return vlimit;
	}

	/*********************************************************
		JointAngles̊m
	*********************************************************/
	inline void allocateJointAngles(
		HiroGateRTC::HiroGateService::JointAngles &angles,
		bool body_head, bool armL, bool armR, bool handL = false, bool handR = false )
	{
		angles.length(5);
		angles[BH].length( body_head ? 3 : 0 );	// ̂Ɠ
		angles[AR].length( armR ? 6 : 0 );	// Er
		angles[AL].length( armL ? 6 : 0 );	// r
		angles[HR].length( handR ? 4 : 0 );	// Er
		angles[HL].length( handL ? 4 : 0 );	// r
	}
	inline void copyJointAngles(
		const HiroGateRTC::HiroGateService::JointAngles &src,
		HiroGateRTC::HiroGateService::JointAngles &dst )
	{
		dst.length( src.length() );
		for( CORBA::ULong i = 0; i < src.length(); ++ i ){
			dst[i].length( src[i].length() );
			for( CORBA::ULong j = 0; j < src[i].length(); ++ j )
				dst[i][j] = src[i][j];
		}
	}
	inline void copyJointAnglesPartly(
		const HiroGateRTC::HiroGateService::JointAngles &src,
		HiroGateRTC::HiroGateService::JointAngles &dst )
	{
		for( CORBA::ULong i = 0; i < src.length(); ++ i ){
			if( src[i].length() )
				for( CORBA::ULong j = 0; j < src[i].length(); ++ j )
					dst[i][j] = src[i][j];
		}
	}

	/*********************************************************
		rw
	*********************************************************/
	enum dominant_side_t { LEFT = +1, RIGHT = -1 };

	inline dominant_side_t decideDominantSide( const RTC::Point3D &p_handR, double torso_angle_rad )
	{
		return ( atan2( p_handR.y, p_handR.x ) > torso_angle_rad ) ? LEFT : RIGHT;
	}
	inline dominant_side_t decideDominantSide( const RTC::Point3D &p_handB )
	{
		return decideDominantSide( p_handB, 0 );
	}


	/*********************************************************
		rfromtorateňړ鎞̓쎞ԂvZ
			ψڊpx threshold_deg Ȃɂ́C
			ő padding_time_s ړԂɒǉ
	*********************************************************/
	static double rate2t(
		dominant_side_t side,
		const HiroGateRTC::HiroGateService::JointAngles &from_rad,
		const HiroGateRTC::HiroGateService::JointAngles &to_rad,
		double rate,
		double padding_time_s = 0.5, double threshold_deg = 10 )
	{
		int arm = ( side == LEFT ) ? AL : AR;
		/* ł傫֐߂ڕW쑬xœƂɌo߂鎞Ԃ𒲂ׂ */
		// ڕW쑬x
		//const double w_deg = 0.01*10*getLimitAngularVelocityDeg(arm);
		//const double w_deg = 0.01*rate*190.0; // ł

		double w_deg = 0.005*rate*getLimitAngularVelocityDeg(arm);

		double dw_rad, dw_rad_max, dw_rad_total = 0;
		dw_rad_max = fabs( from_rad[arm][0] - to_rad[arm][0] );
		for( int i = 1; i < 6; ++ i ){
			dw_rad = fabs( from_rad[arm][i] - to_rad[arm][i] );
			dw_rad_total += dw_rad;
			if( dw_rad > dw_rad_max ) dw_rad_max = dw_rad;
		}
		/*
		printf( "w_deg = %.3f, dw_deg_max = %.3f t = %.3f\n", 
			w_deg, opencv::cvmath::rad2deg( dw_rad_max ), 
			opencv::cvmath::rad2deg( dw_rad_max ) / w_deg );
		*/

		// ړZƂ̕␳
		double t_add = padding_time_s * opencv::cvmath::deg2rad( threshold_deg ) / dw_rad_total;
		t_add = t_add > padding_time_s ? padding_time_s : t_add;
		return opencv::cvmath::rad2deg( dw_rad_max ) / w_deg + t_add;
	}
	static double rate2t(
		RTC::CorbaConsumer<HiroGateRTC::HiroGateService> &hg,
		dominant_side_t side,
		const RTC::Pose3D &from_m_rad, const RTC::Pose3D &to_m_rad,
		double torso_angles_rad, double rate,
		double padding_time_s = 0.5, double threshold_deg = 10 )
	{
		HiroGateRTC::HiroGateService::JointAngles_var from_rad, to_rad;

		if( side == LEFT ) {
			if( !hg->getIKSolutionL( from_m_rad, torso_angles_rad, from_rad ) )
				return -1;
			if( !hg->getIKSolutionL( to_m_rad, torso_angles_rad, to_rad ) )
				return -1;
		}
		else {
			if( !hg->getIKSolutionR( from_m_rad, torso_angles_rad, from_rad ) )
				return -1;
			if( !hg->getIKSolutionR( to_m_rad, torso_angles_rad, to_rad ) )
				return -1;
		}

		return rate2t( side, from_rad, to_rad, rate, padding_time_s, threshold_deg );
	}


	/*********************************************************
		RTC::Pose3D-cvmath::Vector<>Ԍ^ϊ
	*********************************************************/
	// (cvmath::Vector<>, cvmath::Vector<>) -> RTC::Pose3D
	template < int CV_ELEM_T >
	inline void xyzrpy2pose3D(
		const opencv::cvmath::Vector< CV_ELEM_T > &xyz,
		const opencv::cvmath::Vector< CV_ELEM_T > &rpy,
		RTC::Pose3D &pose )
	{
		xyz2point3D( xyz, pose.position );
		rpy2orientation3D( rpy, pose.orientation );
	}
	// cvmath::Vector<> -> RTC::Point3D
	template < int CV_ELEM_T >
	inline void xyz2point3D(
		const opencv::cvmath::Vector< CV_ELEM_T > &xyz,
		RTC::Point3D &position )
	{
		position.x = xyz(0);
		position.y = xyz(1);
		position.z = xyz(2);
	}
	// cvmath::Vector<> -> RTC::Orientation3D
	template < int CV_ELEM_T >
	inline void rpy2orientation3D(
		const opencv::cvmath::Vector< CV_ELEM_T > &rpy,
		RTC::Orientation3D &orientation )
	{
		orientation.r = rpy(0);
		orientation.p = rpy(1);
		orientation.y = rpy(2);
	}

	// RTC::Pose3D -> (cvmath::Vector<>, cvmath::Vector<>)
	template < int CV_ELEM_T >
	inline void pose3D2xyzrpy(
		const RTC::Pose3D &pose,
		opencv::cvmath::Vector< CV_ELEM_T > &xyz,
		opencv::cvmath::Vector< CV_ELEM_T > &rpy )
	{
		point3D2xyz( pose.position, xyz );
		orientation3D2rpy( pose.orientation, rpy );
	}
	// RTC::Point3D -> cvmath::Vector<>
	template < int CV_ELEM_T >
	inline void point3D2xyz(
		const RTC::Point3D &position,
		opencv::cvmath::Vector< CV_ELEM_T > &xyz )
	{
		xyz(0) = position.x;
		xyz(1) = position.y;
		xyz(2) = position.z;
	}
	// RTC::Orientation3D -> cvmath::Vector<>
	template < int CV_ELEM_T >
	inline void orientation3D2rpy(
		const RTC::Orientation3D &orientation,
		opencv::cvmath::Vector< CV_ELEM_T > &rpy )
	{
		rpy(0) = orientation.r;
		rpy(1) = orientation.p;
		rpy(2) = orientation.y;
	}


	/*********************************************************
		{bgZ(̎)̉]
	*********************************************************/
	template < int CV_ELEM_T >
	static void rotateZ(
		const opencv::cvmath::Vector<CV_ELEM_T> &xyz_m,
		const opencv::cvmath::Vector<CV_ELEM_T> &rpy_rad,
		double angle_z_rad,
		opencv::cvmath::Vector<CV_ELEM_T> &rotated_xyz_m,
		opencv::cvmath::Vector<CV_ELEM_T> &rotated_rpy_rad )
	{
		double COS = cos( angle_z_rad ), SIN = sin( angle_z_rad );
		opencv::cvmath::Matrix< CV_ELEM_T > R( 3, 3 );
		R.setI();
		R(0,0) = COS;	R(0,1) = -SIN;
		R(1,0) = SIN;	R(1,1) = COS;
		
		rotated_xyz_m.MxV( R, xyz_m );

		rotated_rpy_rad.set( rpy_rad );
		rotated_rpy_rad(0) += angle_z_rad;
	}
	static void rotateZ(
		const RTC::Pose3D &pose, double angle_z_rad,
		RTC::Pose3D &rotated_pose )
	{
		opencv::cvmath::Vector< CV_64F > xyz_m(3), rpy_rad(3);
		opencv::cvmath::Vector< CV_64F > rotated_xyz_m(3), rotated_rpy_rad(3);

		pose3D2xyzrpy< CV_64F >( pose, xyz_m, rpy_rad );
		rotateZ< CV_64F >( xyz_m, rpy_rad, angle_z_rad, rotated_xyz_m, rotated_rpy_rad );
		xyzrpy2pose3D< CV_64F >( rotated_xyz_m, rotated_rpy_rad, rotated_pose );

	}
	
	/*********************************************************
		{bgnR-̌nBWϊ
	*********************************************************/
	inline void B2R( const RTC::Pose3D &poseB, double torso_angle_rad,
		RTC::Pose3D &poseR )
	{
		rotateZ( poseB, torso_angle_rad, poseR );
	}
	inline void R2B( const RTC::Pose3D &poseR, double torso_angle_rad,
		RTC::Pose3D &poseB )
	{
		rotateZ( poseR, -torso_angle_rad, poseB );
	}


	/*********************************************************
		target_radœKāCpose_handB.position ɓ͂₷
		]px߂
	*********************************************************/
	static double optimizeTorsoAngleRad(
		const RTC::Pose3D &pose_handB_m_rad,
		double target_rad, dominant_side_t left_or_right )
	{
		double res_rad = target_rad;

		const double X = pose_handB_m_rad.position.x;
		const double Y = pose_handB_m_rad.position.y;
		//printf( " (X,Y) = (%.2f, %.2f)\n", X, Y );

#if 1
		if( (left_or_right == LEFT && Y < 0) 
			|| (left_or_right == RIGHT && Y > 0) )
				// ŉEɒuƂ  EōɒuƂ
#endif
		{
			
			const double A = 0.2;
			const double a = left_or_right*A;
			const double b = sqrt((X*X) + (Y*Y) - (A*A));
				//printf( " (a,b) = (%.2f, %.2f)\n", a, b );
			const double SIN = (b*Y - a*X)/(a*a+b*b);
			const double COS = (a*Y + b*X)/(a*a+b*b);
				//printf( " (S,C) = (%.2f, %.2f)\n", SIN, COS );
			const double X_ = b*COS;
			const double Y_ = b*SIN;
				//printf( " (X_,Y_) = (%.2f, %.2f)\n", X_, Y_ );
			res_rad += atan2( Y_, X_ );
		}
		//printf( " %.2f [deg]\n", rad2deg( res_rad ) );
		return res_rad;
	}
	/*********************************************************
		target_radœKāCxyz_handB ɓ͂₷]px߂
	*********************************************************/
	template < int CV_ELEM_T >
	static double optimizeTorsoAngleRad(
		const opencv::cvmath::Vector< CV_ELEM_T > &xyz_handB,
		const opencv::cvmath::Vector< CV_ELEM_T > &rpy_handB,
		double target_rad, dominant_side_t left_or_right )
	{
		RTC::Pose3D pose_handB;
		xyzrpy2pose3D( xyz_handB, rpy_handB, pose_handB );

		return optimizeTorsoAngleRad( pose_handB, target_rad, left_or_right );
	}
	/*********************************************************
		pose_handR.position ɓ͂₷]px߂
	*********************************************************/
	static double optimizeTorsoAngleRad(
		const RTC::Pose3D &pose_handR_m_rad,
		dominant_side_t left_or_right )
	{
		const double X = pose_handR_m_rad.position.x;
		const double Y = pose_handR_m_rad.position.y;
		//printf( " (X,Y) = (%.2f, %.2f)\n", X, Y );

		double res_rad = atan2( Y, X );

#if 1
		if( (left_or_right == LEFT && Y < 0) 
			|| (left_or_right == RIGHT && Y > 0) )
				// ŉEɒuƂ  EōɒuƂ
#endif
		{
			const double A = 0.2;
			const double a = left_or_right*A;
			const double b = sqrt((X*X) + (Y*Y));
				//printf( " (a,b) = (%.2f, %.2f)\n", a, b );
			res_rad -= asin( a / b );
		}

		//printf( " %.2f [deg]\n", rad2deg( res_rad ) );
		return res_rad;
	}



	/*********************************************************
		ẘJw̒߂
	*********************************************************/
	static int calculateFingerDepthFromDistance(
		double distance_mm, double *depth_mm,
		bool base_offset = false,
		bool finger_center = false)
	{
		/* -pxϊ
		def anglesFromDistance(gripDist):
			safetyMargin = 3
			l1 = 33
			l2 = 41.9
			l3 = 30
			l4 = l2 - safetyMargin*2
			l5 = 19

			#if gripDist < 0.0 or gripDist > (l1+l4)*2:
			if gripDist < 0.0 or gripDist > (l2+l5 - safetyMargin)*2:
				return None
			xPos   = gripDist/2.0 + safetyMargin
			#print 'xPos =', xPos
			a2Pos  = xPos - l5
			#print 'a2Pos =', a2Pos
			a1radH = math.acos(a2Pos/l2)
			#print 'a1radH = ', a1radH
			a1rad  = math.pi/2.0 - a1radH
			a2rad  = -a1rad
			dEnd   = l2 * math.cos(a1rad) + l3
			return a1rad, a2rad, -a1rad, -a2rad, dEnd
		*/
		const double
			safetyMargin = 0,
			l1 = 33,
			l2 = 41.9,
			l3 = 30,
			l4 = l2 - safetyMargin*2,
			l5 = 19;
		
		// ~bg`FbN
		if( distance_mm < 0.0 || distance_mm > (l2+l5 - safetyMargin)*2 )
			return -1;

		const double xPos   = distance_mm / 2.0;
		const double a2Pos  = xPos - l5;
		const double a1radH = acos(a2Pos/l2);
		const double a1rad  = M_PI / 2.0 - a1radH;
		const double a2rad  = -a1rad;
		*depth_mm = l2 * cos( a1rad ) + l3 + (base_offset ? 45 : 0) - (finger_center ? 10 : 0);

		return 0;
	}


	/*********************************************************
		ẘJẘ֐ߊp߂
	*********************************************************/
	static int calculateFingerAnglesFromDistance(
		double distance_mm, HiroGateRTC::HiroGateService::FingerAngles &finger_angles_rad, 
		//double backlash0_rad = 0, double backlash1_rad = 0 )
		double backlash_rad = 0 )
	{
		if( finger_angles_rad.length() != 4 ) finger_angles_rad.length( 4 );

		const double
			safetyMargin = 0,
			l1 = 33,
			l2 = 41.9,
			l3 = 30,
			l4 = l2 - safetyMargin*2,
			l5 = 19;
		
		// ~bg`FbN
		if( distance_mm < 0.0 || distance_mm > (l2+l5 - safetyMargin)*2 )
			return -1;

		const double xPos   = distance_mm / 2.0;
		const double a2Pos  = xPos - l5;
		const double a1radH = acos(a2Pos/l2);
		double a1rad  = (M_PI / 2.0 - a1radH);
		double a2rad  = -a1rad;

		// VуlĂX̊pxƂȂ悤ɕ␳
		//a1rad += -backlash0_rad;
		//a2rad += -backlash1_rad;
		a2rad += -backlash_rad;

		finger_angles_rad[0] = +a1rad;
		finger_angles_rad[1] = +a2rad;
		finger_angles_rad[2] = -a1rad;
		finger_angles_rad[3] = -a2rad;

		return 0;
	}

	/*********************************************************
		pǂ𔻒肷
		p1p2̗Ƃɒ`Ă镔i[BH],[AL]ȂǁjɂĔ肷
	*********************************************************/
	static bool isSamePose( 
		const HiroGateRTC::HiroGateService::JointAngles &p1, 
		const HiroGateRTC::HiroGateService::JointAngles &p2,
		double sad_threshold = 0.01 )
	{
		double sad = 0;
		for( int i = 0; i < 5; ++ i ) {
			if( p1[i].length() && p2[i].length() ) {
				for( int j = 0, n = p1[i].length(); i < n; ++ j ) {
					sad += fabs( p1[i][j] - p2[i][j] );
				}
			}
		}
		return sad <= sad_threshold;
	}


	/*********************************************************
		\
	*********************************************************/
	// RTC::Pose3D
	static void printPose3D( const RTC::Pose3D &pose_m_rad )
	{
		using opencv::cvmath::rad2deg;
		printf( "%+6.3f, %+6.3f, %+6.3f, %+7.2f, %+7.2f, %+7.2f\n", 
			pose_m_rad.position.x, pose_m_rad.position.y, pose_m_rad.position.z, 
			rad2deg( pose_m_rad.orientation.y ),
			rad2deg( pose_m_rad.orientation.p ),
			rad2deg( pose_m_rad.orientation.r ) );
	}
	// JointAngles
	static void printJointAngles( const HiroGateRTC::HiroGateService::JointAngles &angles_rad ) {
		using opencv::cvmath::rad2deg;
		if( angles_rad[BH].length() )
			printf( "[Body/Head]: %+6.1f, %+6.1f, %+6.1f\n", 
				rad2deg(angles_rad[BH][0]), rad2deg(angles_rad[BH][1]), rad2deg(angles_rad[BH][2]) );
		if( angles_rad[AR].length() )
			printf( "[ Arm   R ]: %+6.1f, %+6.1f, %+6.1f, %+6.1f, %+6.1f, %+6.1f\n",
				rad2deg(angles_rad[AR][0]), rad2deg(angles_rad[AR][1]), rad2deg(angles_rad[AR][2]), 
				rad2deg(angles_rad[AR][3]), rad2deg(angles_rad[AR][4]), rad2deg(angles_rad[AR][5]) );
		if( angles_rad[AL].length() )
			printf( "[ Arm   L ]: %+6.1f, %+6.1f, %+6.1f, %+6.1f, %+6.1f, %+6.1f\n",
				rad2deg(angles_rad[AL][0]), rad2deg(angles_rad[AL][1]), rad2deg(angles_rad[AL][2]),
				rad2deg(angles_rad[AL][3]), rad2deg(angles_rad[AL][4]), rad2deg(angles_rad[AL][5]) );
		if( angles_rad[HR].length() )
			printf( "[ Hand  R ]: %+6.1f, %+6.1f, %+6.1f, %+6.1f\n", 
				rad2deg(angles_rad[HR][0]), rad2deg(angles_rad[HR][1]), 
				rad2deg(angles_rad[HR][2]), rad2deg(angles_rad[HR][3]) );
		if( angles_rad[HL].length() )
			printf( "[ Hand  L ]: %+6.1f, %+6.1f, %+6.1f, %+6.1f\n",
				rad2deg(angles_rad[HL][0]), rad2deg(angles_rad[HL][1]), 
				rad2deg(angles_rad[HL][2]), rad2deg(angles_rad[HL][3]) );
	}

	
	/**********************************************************
		ivEsjNX
	**********************************************************/
	class OperationNode
	{
	public:
		bool wait_for_motion;
		RTC::CorbaConsumer<HiroGateRTC::HiroGateService> *hg;

	public:
		OperationNode() : wait_for_motion( true ), hg( NULL ) {}
		OperationNode( 
			RTC::CorbaConsumer<HiroGateRTC::HiroGateService> &_hg,
			bool _wait_for_motion )
			: wait_for_motion( _wait_for_motion ), hg( &_hg ) {}
		virtual ~OperationNode() {}
		virtual int act() const = 0;
		virtual void print() const = 0;
		int check() const
		{
			if( !hg ) return -1;
			return rtcutil::isInOperation( *hg ) ? 0 : -1;
		}

	private:
		OperationNode& operator=( const OperationNode& src );
	};
	/**********************************************************
		Sg֐ߊpw
	**********************************************************/
	class JointOperation : public OperationNode
	{
	public:
		
		HiroGateRTC::HiroGateService::JointAngles angles_rad;
		double second;

	public:
		JointOperation() {}
		JointOperation(
			RTC::CorbaConsumer<HiroGateRTC::HiroGateService> &_hg,
			const HiroGateRTC::HiroGateService::JointAngles &_angles_rad,
			double _second, bool _wait_for_motion )
			: OperationNode( _hg, _wait_for_motion ), 
			angles_rad( _angles_rad ), second( _second )
		{}
		// WRs[RXgN^ŖȂ
		// JointOperation( const JointOperation &src );
		~JointOperation() {}
	
	private:
		JointOperation& operator=( const JointOperation& src );

	public:
		int act() const
		{
			if( check() ) return -1;
			(*hg)->setJointAngles( angles_rad, second, wait_for_motion );
			return 0;
		}
		void print() const
		{
			CORBA::ULong i, total = 0;
			for( i = 0, total = 0; i < angles_rad.length(); total += angles_rad[i].length(), ++ i );
			printf( "Joint: %u joints\n", total );
		}
	};
	/**********************************************************
		Ў̎w̓ipxwj
	**********************************************************/
	class FingerAngleOperation : public OperationNode
	{
	public:
		// r
		dominant_side_t side;
		// ֐ߊp
		HiroGateRTC::HiroGateService::FingerAngles angles_rad;
		// b
		double second;	

	public:
		FingerAngleOperation() {}
		FingerAngleOperation(
			RTC::CorbaConsumer<HiroGateRTC::HiroGateService> &_hg,
			dominant_side_t _side,
			const HiroGateRTC::HiroGateService::FingerAngles &_angles_rad,
			double _second, bool _wait_for_motion )
			: OperationNode( _hg, _wait_for_motion ),
			side( _side ), angles_rad( _angles_rad ), second( _second ) {}
		// WRs[RXgN^ŖȂ
		//FingerAngleOperation( const FingerAngleOperation &src );
		~FingerAngleOperation() {}

	private:
		FingerAngleOperation& operator=( const FingerAngleOperation& src );

	public:
		int act() const
		{
			if( check() ) return -1;
			if( side == LEFT )
				(*hg)->setFingerAnglesL( angles_rad, second, wait_for_motion );
			else
				(*hg)->setFingerAnglesR( angles_rad, second, wait_for_motion );
			return 0;
		}

		void print() const
		{
			using opencv::cvmath::rad2deg;
			printf( "Finger %c (Angle): (%+.1f, %+.1f, %+.1f, %+.1f)[deg]\n",
				( side == LEFT ? 'L' : 'R' ),
				rad2deg( angles_rad[0] ), rad2deg( angles_rad[1] ), 
				rad2deg( angles_rad[2] ), rad2deg( angles_rad[3] ) );
		}
	};
	/**********************************************************
		̎w̓ipxwj
	**********************************************************/
	class FingerAngleLROperation : public OperationNode
	{
	public:
		// ֐ߊp
		HiroGateRTC::HiroGateService::FingerAngles 
			angles_l_rad, angles_r_rad;
		// b
		double second;

	public:
		FingerAngleLROperation() {}
		FingerAngleLROperation(
			RTC::CorbaConsumer<HiroGateRTC::HiroGateService> &_hg,
			const HiroGateRTC::HiroGateService::FingerAngles &_angles_l_rad, 
			const HiroGateRTC::HiroGateService::FingerAngles &_angles_r_rad,
			double _second, bool _wait_for_motion )
			: OperationNode( _hg, _wait_for_motion ),
			angles_l_rad( _angles_l_rad ), angles_r_rad( _angles_r_rad ),
			second( _second ) {}
		// WRs[RXgN^ŖȂ
		//FingerAngleLROperation( const FingerAngleLROperation &src );
		~FingerAngleLROperation() {}

	private:
		FingerAngleLROperation& operator=( const FingerAngleLROperation& src );

	public:
		int act() const
		{
			if( check() ) return -1;
			(*hg)->setFingerAnglesL( angles_l_rad, second, false );
			(*hg)->setFingerAnglesR( angles_r_rad, second, false );
			if( wait_for_motion )
				while( (*hg)->isFingerMovingL() || (*hg)->isFingerMovingR() )
					Sleep( 10 );
			return 0;
		}
		void print() const
		{
			using opencv::cvmath::rad2deg;
			printf( "Finger LR (Angle): "
				"L(%+.1f, %+.1f, %+.1f, %+.1f)[deg] "
				"R(%+.1f, %+.1f, %+.1f, %+.1f)[deg]\n",
				rad2deg( angles_l_rad[0] ), rad2deg( angles_l_rad[1] ), 
				rad2deg( angles_l_rad[2] ), rad2deg( angles_l_rad[3] ),
				rad2deg( angles_r_rad[0] ), rad2deg( angles_r_rad[1] ), 
				rad2deg( angles_r_rad[2] ), rad2deg( angles_r_rad[3] ) );
		}
	};
	/**********************************************************
		Ў̎w̓iwj
	**********************************************************/
	class FingerDistanceOperation : public OperationNode
	{
	public:
		dominant_side_t side;	// r
		double width_mm;							// wԋ
		double second;								// b

	public:
		FingerDistanceOperation() {}
		FingerDistanceOperation(
			RTC::CorbaConsumer<HiroGateRTC::HiroGateService> &_hg, 
			dominant_side_t _side, double _width_mm, double _second, 
			bool _wait_for_motion )
			: OperationNode( _hg, _wait_for_motion ),
			side( _side ), width_mm( _width_mm ), second( _second ) {}
		~FingerDistanceOperation() {}

	private:
		FingerDistanceOperation& operator=( const FingerDistanceOperation& src );

	public:
		int act() const
		{
			if( check() ) return -1;
			if( side == hgutil::LEFT )
				(*hg)->setFingerDistanceL( width_mm, second, wait_for_motion );
			else
				(*hg)->setFingerDistanceR( width_mm, second, wait_for_motion );
			return 0;
		}
		void print() const
		{
			printf( "Finger %c (Distance): %+.1f[mm]\n",
				( side == LEFT ? 'L' : 'R' ), width_mm );
		}
	};
	/**********************************************************
		̎w̓iwj
	**********************************************************/
	class FingerDistanceLROperation : public OperationNode
	{
	public:

		double width_l_mm, width_r_mm;	// wԋ
		double second;									// b

	public:
		FingerDistanceLROperation() {}
		FingerDistanceLROperation(
			RTC::CorbaConsumer<HiroGateRTC::HiroGateService> &_hg, 
			double _width_l_mm, double _width_r_mm, double _second,
			bool _wait_for_motion ) 
			: OperationNode( _hg, _wait_for_motion ),
			width_l_mm( _width_l_mm ), width_r_mm( _width_r_mm ),
			second( _second ) {}
		~FingerDistanceLROperation() {}

	private:
		FingerDistanceLROperation& operator=( const FingerDistanceLROperation& src );

	public:
		int act() const
		{
			if( check() ) return -1;
			(*hg)->setFingerDistanceLR( width_l_mm, width_r_mm, second, wait_for_motion );
			return 0;
		}
		void print() const
		{
			printf( "Finger LR (Distance): L/%+.1f[mm] R/%+.1f[mm]\n", 
				width_l_mm, width_r_mm );
		}
	};
	/**********************************************************
		Ў̓iwj
	**********************************************************/
	class HandOperation : public OperationNode
	{
	public:
		dominant_side_t side;			// r
		RTC::Pose3D poseR_m_rad;	// ʒup
		double speed_rate;				// 쑬x

	public:
		HandOperation() {}
		HandOperation(
			RTC::CorbaConsumer<HiroGateRTC::HiroGateService> &_hg,
			dominant_side_t _side, const RTC::Pose3D &_poseR_m_rad,
			double _speed_rate,
			bool _wait_for_motion )
			: OperationNode( _hg, _wait_for_motion ),
			side( _side ), poseR_m_rad( _poseR_m_rad ), 
			speed_rate( _speed_rate ) {}
		//HandOperation( const HandOperation &src );
		~HandOperation() {}

	private:
		HandOperation& operator=( const HandOperation& src );

	public:
		int act() const
		{
			if( check() ) return -1;
			if( side == hgutil::LEFT )
				(*hg)->setHandPoseL( poseR_m_rad, speed_rate, wait_for_motion );
			else
				(*hg)->setHandPoseR( poseR_m_rad, speed_rate, wait_for_motion );
			return 0;
		}
		void print() const
		{
			printf( "Hand %c: ", ( side == hgutil::LEFT ? 'L' : 'R' ) );
				hgutil::printPose3D( poseR_m_rad );
		}
	public:
		static bool isIKSolutionFound(
			RTC::CorbaConsumer<HiroGateRTC::HiroGateService> &hg, 
			dominant_side_t side, const RTC::Pose3D &poseR_m_rad,
			double torso_angle_rad )
		{
			// T[rX̗L
			if( !rtcutil::isInOperation( hg ) ) return false;
			if( side == hgutil::LEFT )
				return hg->isIKSolutionFoundL( poseR_m_rad, torso_angle_rad );
			else
				return hg->isIKSolutionFoundR( poseR_m_rad, torso_angle_rad );
		}
		static bool getIKSolution(
			RTC::CorbaConsumer<HiroGateRTC::HiroGateService> &hg, 
			dominant_side_t side, const RTC::Pose3D &poseR_m_rad,
			double torso_angle_rad, 
			HiroGateRTC::HiroGateService::JointAngles_var &angles_rad )
		{
			// T[rX̗L
			if( !rtcutil::isInOperation( hg ) ) return false;
			if( side == hgutil::LEFT )
				return hg->getIKSolutionL( poseR_m_rad, torso_angle_rad, angles_rad );
			else
				return hg->getIKSolutionR( poseR_m_rad, torso_angle_rad, angles_rad );
		}
	};
	/**********************************************************
		̓
	**********************************************************/
	class HandLROperation : public OperationNode
	{
	public:
		RTC::Pose3D poseR_l_m_rad, poseR_r_m_rad;	// ʒup
		double speed_rate;												// 쑬x

	public:
		HandLROperation() {}
		HandLROperation(
			RTC::CorbaConsumer<HiroGateRTC::HiroGateService> &_hg,
			const RTC::Pose3D &_poseR_l_m_rad, 
			const RTC::Pose3D &_poseR_r_m_rad,
			double _speed_rate, bool _wait_for_motion )
			: OperationNode( _hg, _wait_for_motion ),
			poseR_l_m_rad( _poseR_l_m_rad ), poseR_r_m_rad( _poseR_r_m_rad ),
			speed_rate( _speed_rate ) {}
		//HandLROperation( const HandLROperation &src );
		~HandLROperation() {}

	private:
		HandLROperation& operator=( const HandLROperation& src );

	public:
		int act() const
		{
			if( check() ) return -1;
			(*hg)->setHandPoseLR( poseR_l_m_rad, poseR_r_m_rad, speed_rate, wait_for_motion );
			return 0;
		}
		void print() const
		{
			printf( "Hand LR: L/" );	hgutil::printPose3D( poseR_l_m_rad );
			printf( "Hand LR: R/" );	hgutil::printPose3D( poseR_r_m_rad );
		}
	public:
		static bool isIKSolutionFound(
			RTC::CorbaConsumer<HiroGateRTC::HiroGateService> &_hg, 
			const RTC::Pose3D &poseR_l_m_rad, const RTC::Pose3D &poseR_r_m_rad,
			double torso_angle_rad )
		{
			// T[rX̗L
			if( !rtcutil::isInOperation( _hg ) ) return false;
			bool
				rcL = _hg->isIKSolutionFoundL( poseR_l_m_rad, torso_angle_rad ),
				rcR = _hg->isIKSolutionFoundR( poseR_r_m_rad, torso_angle_rad );
			return rcL && rcR;
		}
	};
	/**********************************************************
		ԑ҂
	**********************************************************/
	class SleepOperation : public OperationNode
	{
	public:
		double second;

	public:
		SleepOperation( double _second = 0 ) : second( _second ) {}
		~SleepOperation() {}
	
	private:
		SleepOperation& operator=( const SleepOperation& src );

	public:
		int act() const { Sleep( DWORD(1000*second) ); return 0; }
		void print() const { printf( "Sleep : %.3f[s]\n", second ); }

	};

}

