#pragma once


#include <vector>
#include <rtm/idl/BasicDataTypeSkel.h>
#include <rtm/idl/ExtendedDataTypesSkel.h>
#include "../HiroGate/hgutil.h"

#if 1
#include "HiroNXStub.h"
#include "HIROControllerStub.h"
	// ʏ킱̏ł́Chgutil.hƓfBNg(HiroGate)̃t@C
	// 荞܂邪CRTCBuilderŐꂽVCvWFNgł́C
	// uǉ̃CN[hfBNgv"."w肳Ă̂ŁC
	// HiroGateRTCStub.h̓vWFNg̍ƃfBNgǂݍ܂D
#else
// HiroNXGate
#include "HiroNXGateRTCStub.h"
	// ʏ킱̏ł́Chgutil.hƓfBNg(HiroGate)̃t@C
	// 荞܂邪CRTCBuilderŐꂽVCvWFNgł́C
	// uǉ̃CN[hfBNgv"."w肳Ă̂ŁC
	// HiroGateRTCStub.h̓vWFNg̍ƃfBNgǂݍ܂D
#endif

#include "../rtcutil/rtcutil.h"
#include "../VSCommon/opencv/cvmath/cvmath.h"


namespace nxutil
{

	/**********************************************************
		\
	**********************************************************/
	static void printJointPos( const MotionCommands::JointPos &dst_deg )
	{	
		printf( "(Body/Head): %+6.1f, %+6.1f, %+6.1f\n",
			dst_deg[0], dst_deg[1], dst_deg[2] );
		
		printf( "( Arm   R ): %+6.1f, %+6.1f, %+6.1f, %+6.1f, %+6.1f, %+6.1f\n",
			dst_deg[3], dst_deg[4], dst_deg[5], dst_deg[6], dst_deg[7], dst_deg[8] );
		printf( "( Arm   L ): %+6.1f, %+6.1f, %+6.1f, %+6.1f, %+6.1f, %+6.1f\n",
			dst_deg[9], dst_deg[10], dst_deg[11], dst_deg[12], dst_deg[13], dst_deg[14] );
		
		printf( "( Hand  R ): %+6.1f, %+6.1f, %+6.1f, %+6.1f\n", 
			dst_deg[15], dst_deg[16], dst_deg[17], dst_deg[18] );
		
		printf( "( Hand  L ): %+6.1f, %+6.1f, %+6.1f, %+6.1f\n",
			dst_deg[19], dst_deg[20], dst_deg[21], dst_deg[22] );
	}


	static void printDoubleSeq( const MotionCommands::DoubleSeq &dst_deg )
	{
		printf( "(Hand): %+6.1f, %+6.1f, %+6.1f, %+6.1f\n", 
			dst_deg[0], dst_deg[1], dst_deg[2], dst_deg[3] );
	}


	/**********************************************************
		HiroGate-HiroNXGateԃf[^ϊ
	**********************************************************/
	// srcdst
	static void Hiro2HiroNX(
		const HiroGateRTC::HiroGateService::JointAngles &src_rad,
		MotionCommands::JointPos &dst_deg, bool clear = false )
	{
		using opencv::cvmath::rad2deg;
		// mۂĂȂΊm
		if( !dst_deg.length() )	dst_deg.length( 3+2*(6+4) );
		// KvȂ0NA
		if( clear )
			for( int i = 0; i < 3+2*(6+4); ++ i ) dst_deg[i] = 0.0;
		
		if( src_rad[0].length() == 3 )
			for( int i = 0; i < 3; ++ i ) dst_deg[i] = rad2deg( src_rad[0][i] );
		
		if( src_rad[1].length() == 6 )
			for( int i = 0; i < 6; ++ i ) dst_deg[3+i] = rad2deg( src_rad[1][i] );
		
		if( src_rad[2].length() == 6 )
			for( int i = 0; i < 6; ++ i ) dst_deg[3+6+i] = rad2deg( src_rad[2][i] );
		
		if( src_rad[3].length() == 4 )
			for( int i = 0; i < 4; ++ i ) dst_deg[3+6+6+i] = rad2deg( src_rad[3][i] );
		
		if( src_rad[4].length() == 4 )
			for( int i = 0; i < 4; ++ i ) dst_deg[3+6+6+4+i] = rad2deg( src_rad[4][i] );
	}
	
	
	// srcɂȂbase⊮
	static void Hiro2HiroNX(
		const HiroGateRTC::HiroGateService::JointAngles &src_rad,
		const HiroGateRTC::HiroGateService::JointAngles &base_rad,
		MotionCommands::JointPos &dst_deg, bool clear = false )
	{			
		// ܂baseCsrcRs[
		Hiro2HiroNX( base_rad, dst_deg, clear );
		Hiro2HiroNX( src_rad, dst_deg, false );
	}
	
	
	// ẘ֐ߊp݂̂Rs[
	static void Hiro2HiroNX(
		const HiroGateRTC::HiroGateService::FingerAngles *finger_l_rad,
		const HiroGateRTC::HiroGateService::FingerAngles *finger_r_rad,
		MotionCommands::JointPos &dst_deg )
	{
		using opencv::cvmath::rad2deg;

		if( finger_r_rad && finger_r_rad->length() == 4 )
			for( int i = 0; i < 4; ++ i ) dst_deg[3+6+6+i] = rad2deg( (*finger_r_rad)[i] );
		if( finger_l_rad && finger_l_rad->length() == 4 )
			for( int i = 0; i < 4; ++ i ) dst_deg[3+6+6+4+i] = rad2deg( (*finger_l_rad)[i] );
	}
	
	
	static void Hiro2HiroNX(
		const HiroGateRTC::HiroGateService::FingerAngles &src_rad,
		MotionCommands::DoubleSeq &dst_deg )
	{
		using opencv::cvmath::rad2deg;
		if( !dst_deg.length() )
			dst_deg.length( 4 );

		if( src_rad.length() == 4 )
			for( int i = 0; i < 4; ++ i ) dst_deg[i] = rad2deg( src_rad[i] );

	}
	
	
	// 
	static void HiroNX2Hiro( 
		const MotionCommands::JointPos &src_deg,
		HiroGateRTC::HiroGateService::JointAngles &dst_rad )
	{
		using opencv::cvmath::deg2rad;
		
		int i;
		for( i = 0; i < 3;         ++ i ) dst_rad[hgutil::BH][i]         = deg2rad( src_deg[i] );
		for(      ; i < 3+6;       ++ i ) dst_rad[hgutil::AR][i-3]       = deg2rad( src_deg[i] );
		for(      ; i < 3+6+6;     ++ i ) dst_rad[hgutil::AL][i-3-6]     = deg2rad( src_deg[i] );
		for(      ; i < 3+6+6+4;   ++ i ) dst_rad[hgutil::HL][i-3-6-6]   = deg2rad( src_deg[i] );
		for(      ; i < 3+6+6+4+4; ++ i ) dst_rad[hgutil::HR][i-3-6-6-4] = deg2rad( src_deg[i] );
	}
	

	/*
	// x-ϊ
	static double HiroNX2Hiro( double speed_rate )
	{
		static const double MIN_TIME = 1, MAX_TIME = 8;
		static const double MIN_RATE = 5, MAX_RATE = 50;
		if( speed_rate < MIN_RATE )	return MAX_TIME;
		if( MAX_RATE < speed_rate )	return MIN_TIME;
		
		const double a = (MIN_TIME - MAX_TIME) / (MAX_RATE - MIN_RATE);
		const double b = MAX_TIME - a*MIN_RATE;

		return a * speed_rate + b;
	}
	*/


	// HirGatěv悩HiroNXGatěv֕ϊ
	static HiroGateRTC::HiroGateService::JointAngles Hiro2HiroNX(
		std::vector< hgutil::OperationNode * > ope_nodes,
		const HiroGateRTC::HiroGateService::JointAngles &angles_base_rad,
		MotionCommands::JointPosSeq &jpseq,
		MotionCommands::DoubleSeq &tmseq )
	{
		std::cout << ">> nxutil::Hiro2HiroNX()" << std::endl;

		using hgutil::OperationNode;
		using hgutil::JointOperation;
		using hgutil::FingerAngleOperation;
		using hgutil::FingerAngleLROperation;
		using hgutil::FingerDistanceOperation;
		using hgutil::FingerDistanceLROperation;
		using hgutil::HandOperation;
		using hgutil::HandLROperation;
		using hgutil::SleepOperation;

		CORBA::ULong ope_i, ope_n = CORBA::ULong( ope_nodes.size() );
		jpseq.length( CORBA::ULong( ope_nodes.size() ) );
		tmseq.length( CORBA::ULong( ope_nodes.size() ) );

		HiroGateRTC::HiroGateService::JointAngles angles_rad;
		hgutil::allocateJointAngles( angles_rad, true, true, true, true, true );
		for( CORBA::ULong i = 0; i < angles_rad.length(); ++ i )
			if( angles_base_rad[i].length() )
				for( CORBA::ULong j = 0; j < angles_rad[i].length(); ++ j )
					angles_rad[i][j] = angles_base_rad[i][j];
			else
				for( CORBA::ULong j = 0; j < angles_rad[i].length(); ++ j )
					angles_rad[i][j] = 0.0;

		double second = 5;

		for( ope_i = 0; ope_i < ope_n; ++ ope_i ) {	

			printf( "%u: ", ope_i );
			
			hgutil::OperationNode *node = ope_nodes[ope_i];

			if( dynamic_cast< const JointOperation * >( node ) ) {
				const JointOperation &_node = 
					*dynamic_cast< const JointOperation * >( node );
				_node.print();

				hgutil::copyJointAnglesPartly( _node.angles_rad, angles_rad );
				second = _node.second;
			}

			if( dynamic_cast< const FingerAngleOperation * >( node ) ) {
				const FingerAngleOperation &_node = 
					*dynamic_cast< const FingerAngleOperation * >( node );
				_node.print();
				angles_rad[_node.side == hgutil::LEFT ? hgutil::HL : hgutil::HR ] = _node.angles_rad;
					// ꂪ@\Ȃ΁Csequence< double >  
					// typedef ̂͌݊Ƃ
				second = _node.second;
			}

			if( dynamic_cast< const FingerAngleLROperation * >( node ) ) {
				const FingerAngleLROperation &_node = 
					*dynamic_cast< const FingerAngleLROperation * >( node );
				_node.print();

				angles_rad[hgutil::HL] = _node.angles_l_rad;
				angles_rad[hgutil::HR] = _node.angles_r_rad;
				second = _node.second;
			}

			if( dynamic_cast< const FingerDistanceOperation * >( node ) ) {
				const FingerDistanceOperation &_node = 
					*dynamic_cast< const FingerDistanceOperation * >( node );
				_node.print();

				// ֐ߊpvZ
				HiroGateRTC::HiroGateService::FingerAngles f;
				f.length( 4 );
				hgutil::calculateFingerAnglesFromDistance( _node.width_mm, f );

				angles_rad[_node.side == hgutil::LEFT ? hgutil::HL : hgutil::HR ] = f;
				second = _node.second;
			}

			if( dynamic_cast< const FingerDistanceLROperation * >( node ) ) {
				const FingerDistanceLROperation &_node =
					*dynamic_cast< const FingerDistanceLROperation * >( node );
				_node.print();

				HiroGateRTC::HiroGateService::FingerAngles fL, fR;
				fL.length( 4 ), fR.length( 4 );

				hgutil::calculateFingerAnglesFromDistance( _node.width_l_mm, fL );
				hgutil::calculateFingerAnglesFromDistance( _node.width_r_mm, fR );
				angles_rad[hgutil::HL] = fL;
				angles_rad[hgutil::HR] = fR;

				second = _node.second;
			}

			if( dynamic_cast< const HandOperation * >( node ) ) {
				HandOperation &_node =
					*dynamic_cast< HandOperation * >( node );
				_node.print();

				// IK(֐ߊp)𓾂
				HiroGateRTC::HiroGateService::JointAngles_var h;
				hgutil::HandOperation::getIKSolution( *_node.hg,
					_node.side, _node.poseR_m_rad, angles_rad[hgutil::BH][0], h );

				second = hgutil::rate2t( _node.side, angles_rad, h, _node.speed_rate );
				hgutil::copyJointAnglesPartly( h, angles_rad );
			}

			if( dynamic_cast< const HandLROperation * >( node ) ) {
				HandLROperation &_node =
					*dynamic_cast< HandLROperation * >( node );
				_node.print();

				HiroGateRTC::HiroGateService::JointAngles_var hL, hR;

				// IK(֐ߊp)𓾂
				hgutil::HandOperation::getIKSolution( *_node.hg,
					hgutil::LEFT, _node.poseR_l_m_rad, angles_rad[hgutil::BH][0], hL );
				hgutil::HandOperation::getIKSolution( *_node.hg,
					hgutil::RIGHT, _node.poseR_r_m_rad, angles_rad[hgutil::BH][0], hR );

				double secL = hgutil::rate2t( hgutil::LEFT, angles_rad, hL, _node.speed_rate );
				double secR = hgutil::rate2t( hgutil::RIGHT, angles_rad, hR, _node.speed_rate );

				hgutil::copyJointAnglesPartly( hL, angles_rad );
				hgutil::copyJointAnglesPartly( hR, angles_rad );
				
				second = secL > secR ? secL : secR;
			}

			if( dynamic_cast< const SleepOperation * >( node ) )	{
				const SleepOperation &_node =
					*dynamic_cast< const SleepOperation * >( node );
				_node.print();

				// p _node.second b|Ĉړ
				// angles_rad = angles_rad;
				second = _node.second;
			}


			jpseq[ope_i].length( 24 ); // 23+1
			Hiro2HiroNX( angles_rad, jpseq[ope_i] );
			tmseq[ope_i] = second;

			printf( "second = %.3f\n", second );

		}

		std::cout << "<< nxutil::Hiro2HiroNX()" << std::endl;

		// ŏIpԂ(̓̏pƂėp\邽)
		return angles_rad;
	}

}
