#ifdef HIROPNP_USE_DOUBLE_ARM_COMMON_IF
#include "../HiroNXGate/nxutil.h"
#endif
#include "HiroPickerAndPlacer.h"
#include "../StateMachine/smutil.h"
#include "../VSCommon/system/misc/misc.h"


using namespace std;
using namespace opencv;
using rtcutil::isInOperation;
using hgutil::OperationNode;


/**********************************************************
	͕
**********************************************************/
namespace in
{
	STATIC_CONST_STRING( HIRO_OBJ_MANIP_START );
	STATIC_CONST_STRING( HIRO_OBJ_MANIP_STOP );
	
	STATIC_CONST_STRING( HIRO_TRAY_MANIP_START );
	STATIC_CONST_STRING( HIRO_TRAY_MANIP_STOP );

	STATIC_CONST_STRING( FINISH );
}


/**********************************************************
	o͕
**********************************************************/
namespace out
{
	STATIC_CONST_STRING( HIRO_OBJ_MANIP_FINISHED );
	STATIC_CONST_STRING( HIRO_OBJ_MANIP_ERROR );
	STATIC_CONST_STRING( HIRO_OBJ_MANIP_STOPPED );

	STATIC_CONST_STRING( HIRO_TRAY_MANIP_FINISHED );
	STATIC_CONST_STRING( HIRO_TRAY_MANIP_ERROR );
	STATIC_CONST_STRING( HIRO_TRAY_MANIP_STOPPED );
}


/**********************************************************
	onExecute()̖{
**********************************************************/
int HiroPickerAndPlacer::process()
{
	bool &in_obj_manip = pnp::operation_t::in_obj_manip;
	bool &in_tray_manip = pnp::operation_t::in_tray_manip;
	sys::Thread &thread = pnp::operation_t::thread;

	string &input = pnp::operation_t::input;
	string &output = pnp::operation_t::output;

	bool output_ready = false;

	// ̓`FbN
	if( m_inputIn.isNew() ) {
		m_inputIn.read();

		if( smutil::checkPrefix( m_input.data[0], "HIRO" ) ) {
			// 擪"HIRO"̂Ƃ
			
			/* ͂ɑ΂鏈Əo */
			input = m_input.data[0];

			if( input.length() < 6 )
				return 0;

			cout << ">> " << input << endl;

			if( input[5] == 'O' ) {
				/* ̂̏ */

				if( input == in::HIRO_OBJ_MANIP_STOP ) {
					// IuWFNg̒~
					stopThread( &in_obj_manip );
					output = out::HIRO_OBJ_MANIP_STOPPED;
					output_ready = true;
				}
				else if( input == in::HIRO_OBJ_MANIP_START ) {
					in_obj_manip = true;
					thread.start( processObj, this );

					// ׂāCvvœ̓|[g邱ƂKv
					// iG[̃bZ[W󂯎邽߁j

					// ̂͂ނƂIKsȂ΁C
					// HIRO_OBJ_MANIP_ERROR𔭍sD
					// HIRO_TRAY_MANIP_STARTꍇ
					// HIRO_TRAY_MANIP_ERROR 𔭍s邱ƁD
					//   ̂͂߂Ȃ̂ŁĈuꂽ܂
					//   gCuꏊ\
				}
			}
			else if( input[5] == 'T' ) {
				/* gC̏ */
				if( input == in::HIRO_TRAY_MANIP_STOP ) {
					// gC̒~
					stopThread( &in_tray_manip );
					output = out::HIRO_TRAY_MANIP_STOPPED;
					output_ready = true;
				}
				else if( input == in::HIRO_TRAY_MANIP_START ) {
					// gC̊Jn
					in_tray_manip = true;
					thread.start( processTray, this );
				}
			}
		}
		else if( string( m_input.data[0] ) == in::FINISH ) {
			/* ď */
			activate();
			output = "";
			output_ready = true;
		}
	}


	// ̂gC̑쒆
	if( in_obj_manip || in_tray_manip ) {
		if( thread.wait( 5 ) == WAIT_OBJECT_0 ) {
			// 삪I
			// Xbh~Čʂo
			thread.stop();

			if( in_obj_manip ) in_obj_manip = false;
			if( in_tray_manip ) in_tray_manip = false;

			output_ready = true;
		}
	}

	if( output_ready ) {
		cout << "<< " << output << endl;
		//output = out::HIRO_OBJ_MANIP_FINISHED;
		smutil::write( output, m_output, m_outputOut );
	}

	return 0;
}


/**********************************************************
	̂̃}js[V
**********************************************************/
unsigned int __stdcall HiroPickerAndPlacer::processObj(
	void *hiro_pnp_ptr )
{
#if 1	//---------------------------------------------------
	HiroPickerAndPlacer &hiro_pnp = *(HiroPickerAndPlacer *) hiro_pnp_ptr;

	/* HIRO̊mF */
#	if HIROPNP_USE_DOUBLE_ARM_COMMON_IF
	//  opetaion_t::is_hiro_connected ŒׂׂȂ

#	if 1
	if( !isInOperation( hiro_pnp.motion ) )
		sys::returnByError( -1,
			"HiroPickerAndPlacer::processObj(): "
			"HIROController does not respond." );
#	else
	if( !isInOperation( hiro_pnp.hnxg ) )
		sys::returnByError( -1,
			"HiroPickerAndPlacer::processObj(): "
			"HiroNXGate does not respond." );
#	endif

#	endif
	//  opetaion_t::is_hiro_connected ŒׂׂȂ
	if( !isInOperation( hiro_pnp.hg ) )
		sys::returnByError( -1,
			"HiroPickerAndPlacer::processObj(): "
			"HiroGate does not respond." );

	/* ID, ̂̃{bgWnʒup̎擾 */
	CORBA::Long rc, model_id;
	RTC::Size3D size_obj_m;
	RTC::Pose3D pose_objR_m_rad;

	// En{bgnItZbg
	const pnp::configuration_parameter_t &conf = hiro_pnp.conf;
	RTC::Pose3D W2R_m_rad;
	W2R_m_rad.position.x = conf.worldR_m(0);
	W2R_m_rad.position.y = conf.worldR_m(1);
	W2R_m_rad.position.z = conf.worldR_m(2);
	W2R_m_rad.orientation.y = cvmath::deg2rad( conf.worldR_deg );
	W2R_m_rad.orientation.r = W2R_m_rad.orientation.p = 0;

	std::string &output = pnp::operation_t::output;

#	if 1
		
	// ̈ʒup茋ʂ̎擾
	if( !isInOperation( hiro_pnp.ope ) ) {
		output = out::HIRO_OBJ_MANIP_ERROR;
		return sys::returnByError( -1,
			"HiroPickerAndPlacer::processObj(): "
			"ObjectPoseEstimationGate does not respond." );
	}
	rc = hiro_pnp.ope->getLastEstimatedResult(
		W2R_m_rad, model_id, size_obj_m, pose_objR_m_rad );

#	else

	pose_objR_m_rad.position.x = +0.425;
	pose_objR_m_rad.position.y = -0.072;
	pose_objR_m_rad.position.z = +0.068;
	pose_objR_m_rad.orientation.y = cvmath::deg2rad( +43.45 );
	pose_objR_m_rad.orientation.p = +0.00;
	pose_objR_m_rad.orientation.r = +0.00;
	
	model_id = 1;

	size_obj_m.w = 0.001 * 30.0;
	size_obj_m.h = 0.001 * 40.0;

	rc = 0;

#	endif

	if( rc != -1 ) {
		// ̂ꍇ
		cout << "Object found." << endl;
		cout << "+id=" << model_id << endl;

		size_obj_m.w = (model_id == 1) ? 0.050 : 0.030;

		pose_objR_m_rad.position.y = (model_id == 1)? -0.10 : +0.10;

		rc = hiro_pnp.manipulateSingleObject(
			model_id, size_obj_m, pose_objR_m_rad );

		if( rc ) output = out::HIRO_OBJ_MANIP_FINISHED;
		else     output = out::HIRO_OBJ_MANIP_ERROR;
			
	}
	else {
		// ̂ȂꍇG[
		// iȂꍇ́C{ɗOɁCʏԂɑJڂĂ͂j
		cout << "-id=" << model_id << endl;
		output = out::HIRO_OBJ_MANIP_ERROR;
	}

#	else //--------------------------------------------------
	// eXg
	printf( ">> TEST\n" );
	Sleep( 10000 );
	pnp::operation_t::output = out::HIRO_OBJ_MANIP_FINISHED;
	printf( "<< TEST\n" );
#	endif //-------------------------------------------------

	return 0;
}


/**********************************************************
	gC̃}js[V
**********************************************************/
unsigned int __stdcall HiroPickerAndPlacer::processTray(
	void *hiro_pnp_ptr )
{
	HiroPickerAndPlacer &hiro_pnp = *(HiroPickerAndPlacer *) hiro_pnp_ptr;
		
#	if HIROPNP_USE_DOUBLE_ARM_COMMON_IF
	//  opetaion_t::is_hiro_connected ŒׂׂȂ
#	if 1
	if( !isInOperation( hiro_pnp.motion ) )
		sys::returnByError( -1,
			"HiroPickerAndPlacer::processTray(): "
			"HIROController does not respond." );
#	else
	if( !isInOperation( hiro_pnp.hnxg ) )
		sys::returnByError( -1,
			"HiroPickerAndPlacer::processTray(): "
			"HiroNXGate does not respond." );
#	endif

#	endif
	//  opetaion_t::is_hiro_connected ŒׂׂȂ
	if( !isInOperation( hiro_pnp.hg ) )
		return sys::returnByError( -1,
			"HiroPickerAndPlacer::processTray(): "
			"HiroGate does not respond." );

	std::string &output = pnp::operation_t::output;

	if( hiro_pnp.manipulateTray() )
		output = out::HIRO_TRAY_MANIP_FINISHED;
	else
		output = out::HIRO_TRAY_MANIP_ERROR;

	return 0;
}


/**********************************************************
	v̎s
**********************************************************/
#	ifdef HIROPNP_USE_DOUBLE_ARM_COMMON_IF

int HiroPickerAndPlacer::actPlan(
	const std::vector< hgutil::OperationNode* > &ope_nodes,
	const HiroGateRTC::HiroGateService::JointAngles *angles_base_rad )
{
	printf( "Action (Common I/F)" ), fflush( stdout );

	static HiroGateRTC::HiroGateService::JointAngles last_pose;

	// ʃC^tF[X̃f[^ɕϊ
	MotionCommands::JointPosSeq jpseq;
	MotionCommands::DoubleSeq tmseq;

	// angles_base_rad w肳Ă΁CpɁC
	// Ȃ last_pose pɎg
	last_pose = nxutil::Hiro2HiroNX(
		ope_nodes, angles_base_rad ? *angles_base_rad : last_pose,
		jpseq, tmseq );
		// last_pose̊mۑOɏpƂlast_posegƗ\
		// wE͂邯Ǎ͑ΏȂ

#	if 1
	// HIROControllerʂĎs
	

	if( pnp::operation_t::is_hiro_connected ) {
		const MotionCommands::RETURN_ID *res;
		res = motion->movePTPJointAbsSeq( jpseq, tmseq );
		return res->id;
	}

	return -1;

#	else
	// HiroNXGateʂĎs
	return
		(pnp::operation_t::is_hiro_connected ? 1 : 0)
		&& hnxg->setJointPosSeq( jpseq, tmseq );
#	endif

}

#else

int HiroPickerAndPlacer::actPlan(
	const std::vector< hgutil::OperationNode* > &ope_nodes )
{
	printf( "Action" ), fflush( stdout );

	vector< OperationNode* >::const_iterator it;
	for( it = ope_nodes.begin(); it != ope_nodes.end(); ++ it ) {
		(*it)->print();
		if( (pnp::operation_t::is_hiro_connected ? 1 : 0)
			&& (*it)->act() )
			return sys::returnByError( -1,
				"HiroPickerAndPlacer::actPlan(): failed to place." );

	}
	return 0;
}

#endif


/**********************************************************
	v̍폜
**********************************************************/
void HiroPickerAndPlacer::deletePlan( vector< OperationNode *> &ope_nodes )
{
	vector< OperationNode* >::iterator it;
	for( it = ope_nodes.begin(); it != ope_nodes.end(); ++ it ) {
		if( *it ) {
			delete *it;
			*it = NULL;
		}
	}
}


#ifdef HIROPNP_USE_DOUBLE_ARM_COMMON_IF


#endif