#include "ObjectPoseEstimationGate.h"

#include "../rtcutil/rtcutil.h"
#include "../StateMachine/smutil.h"
#include <iostream>
#include <string>


using namespace std;


namespace out
{
	STATIC_CONST_STRING( OPE_EST_FOUND );
	STATIC_CONST_STRING( OPE_1ST_EST_NOT_FOUND );
	STATIC_CONST_STRING( OPE_EST_NOT_FOUND );
}


/*=========================================================
	v̏
=========================================================*/
int ObjectPoseEstimationGate::processRequestToEstimate( std::string &output )
{
	cout
		<< "Trying to find model #" << model_id_to_be_tried << endl
		<< "\tn_result = " << n_result << endl
		<< "\tresult_idx = " << result_idx << endl;

	/* 蕨̃L[̎c蕨̐ɉĐ/ʎo */
	int n_rest = n_result-result_idx;
	if( !n_rest ) {
		/* c蕨̂Ȃꍇ͍Đ */
#		ifdef OPEG_OPERATION_WITHOUT_OPE //====================
#		else //================================================
		rec_svc->setModelID( model_id_to_be_tried );
#		endif //===============================================
		
		// 蒆
		in_estimation = true;
	}
	else { 
		/*if( result_idx != n_result ) { */
		/* ɐ茋ʂꍇ */
		// w肳镨̂𐄒茋ʂ̂̕OPEGT[rXɑo
		dequeueResult();

		// o͕ݒ
		output = out::OPE_EST_FOUND;
	}

	// 菈v͏
	request_to_estimate = false;

	return 0;
}


#ifdef OPEG_OPERATION_WITHOUT_OPE //======================
/*=========================================================
	_~[f[^̃Zbg
=========================================================*/
int setDummyData( 
	int model_id,
	const opencv::cvmath::Matrix< CV_64F > &Robj,
	const opencv::cvmath::Vector< CV_64F > &t,
	RTC::TimedDoubleSeq &rec_res, int obj_base_idx ) 
{
	rec_res.data[obj_base_idx+ 0] = 0;
	rec_res.data[obj_base_idx+ 1] = model_id;
	rec_res.data[obj_base_idx+ 2] = 0;
	rec_res.data[obj_base_idx+ 3] = 0;

	rec_res.data[obj_base_idx+ 4] = 0.9;
	rec_res.data[obj_base_idx+ 5] = 0;
	rec_res.data[obj_base_idx+ 6] = 0;
	rec_res.data[obj_base_idx+ 7] = 0;

	rec_res.data[obj_base_idx+ 8] = Robj(0,0);
	rec_res.data[obj_base_idx+ 9] = Robj(0,1);
	rec_res.data[obj_base_idx+10] = Robj(0,2);
	rec_res.data[obj_base_idx+11] =    t(0);
			
	rec_res.data[obj_base_idx+12] = Robj(1,0);
	rec_res.data[obj_base_idx+13] = Robj(1,1);
	rec_res.data[obj_base_idx+14] = Robj(1,2);
	rec_res.data[obj_base_idx+15] =    t(1);

	rec_res.data[obj_base_idx+16] = Robj(2,0);
	rec_res.data[obj_base_idx+17] = Robj(2,1);
	rec_res.data[obj_base_idx+18] = Robj(2,2);
	rec_res.data[obj_base_idx+19] =    t(2);

	return 0;
}
#endif


/*=========================================================
	茋ʂ̏
=========================================================*/
int ObjectPoseEstimationGate::processResult( std::string &output )
{
	/*
		[ 0]    Camera Set ID
		[ 1]    Object ID
		[ 2]    Candidate No.
		[ 3]    Coordinate system No.
		[ 4]    Recognition reliability
		[ 5]    Error No.
		[ 6]    Reserve 1
		[ 7]    Reserve 2
		[ 8-11] r000, r001, r002, t0x,
		[12-15] r010, r011, r012, t0y,
		[16-19] r020, r021, r022, t0z,
	*/

# ifdef OPEG_OPERATION_WITHOUT_OPE //======================
	
	// _~[f[^̃Zbg
	{
		static bool first_estimation = true;
		
		if( first_estimation ) {
			/* 1ڂ̐(2̂̕) */
			printf( "OPEG 1st estimation\n" );
			m_rec_res.data.length( 2*REC_RES_N_ELEM );
			using opencv::cvmath::deg2rad;
			{	
				// 1(fID=0)
				opencv::cvmath::RotationManager< CV_64F > rm;
				const opencv::cvmath::Matrix< CV_64F > 
					&R = rm.getRzyxEuler(
						deg2rad(30),
						deg2rad(5),
						deg2rad(2) );
				
				opencv::cvmath::Vector< CV_64F > t( 3 );
				t(0) = +0.05;
				t(1) = -0.0;
				t(2) =  0.025+0.01;

				setDummyData( 0, R, t, m_rec_res, 0*REC_RES_N_ELEM );
			}
			{	
				// 2(fID=1)
				opencv::cvmath::RotationManager< CV_64F > rm;
				const opencv::cvmath::Matrix< CV_64F > 
					&R = rm.getRzyxEuler(
						deg2rad(20),
						deg2rad(5),
						deg2rad(2) );
				
				opencv::cvmath::Vector< CV_64F > t( 3 );
				t(0) = -0.05;
				t(1) = +0.25;
				t(2) =  0.030+0.01;
				
				setDummyData( 1, R, t, m_rec_res, 1*REC_RES_N_ELEM );
			}
			first_estimation = false;
		}
		else {
			/* 2ڂ̐(Ȃ) */
			printf( "OPEG 2nd estimation\n" );
			m_rec_res.data.length( 1*REC_RES_N_ELEM );
			opencv::cvmath::RotationManager< CV_64F > rm;
				
				const opencv::cvmath::Matrix< CV_64F > 
					&R = rm.getRzyxEuler( 0, 0, 0 );
				
				opencv::cvmath::Vector< CV_64F > t( 3 );
				t.setZero();
				
				setDummyData( 0, R, t, m_rec_res, 0*REC_RES_N_ELEM );
				
				m_rec_res.data[5] = -102;
		}
	}

	{

#	else //==================================================
	
	if( m_rec_resIn.isNew() ) {	
		m_rec_resIn.read();

#	endif //=================================================

#		ifdef OPEG_FIND_ONE_OBJECT //--------------------------

		double reliability = m_rec_res.data[4];
		int error_no = int( m_rec_res.data[5] );
		if( error_no != -102 && reliability >= 0.8 ) {
			// Mx臒lُŌꍇ

			typedef opencv::cvmath::Matrix< CV_64F > M64;
			typedef opencv::cvmath::Vector< CV_64F > V64;

			/* pݒ */
			RTC::Pose3D pobj_m_rad;

			// ]s̃Rs[
			M64 R( 3, 3 );
			V64 t( 3 );

			R(0,0) = m_rec_res.data[8];
			R(0,1) = m_rec_res.data[9];
			R(0,2) = m_rec_res.data[10];
			t(0)   = m_rec_res.data[11];
			
			R(1,0) = m_rec_res.data[12];
			R(1,1) = m_rec_res.data[13];
			R(1,2) = m_rec_res.data[14];
			t(1)   = m_rec_res.data[15];
			
			R(2,0) = m_rec_res.data[16];
			R(2,1) = m_rec_res.data[17];
			R(2,2) = m_rec_res.data[18];
			t(2)   = m_rec_res.data[19];

			// ]s񂩂IC[p
			opencv::cvmath::RotationMatrixDecomposer< CV_64F > rmd;
			const V64 &euler = rmd.decomposeRzRyRxEuler( R );

			// i
			pobj_m_rad.position.x = t(0);
			pobj_m_rad.position.y = t(1);
			pobj_m_rad.position.z = t(2);
			// ]
			pobj_m_rad.orientation.y = euler(2);
			pobj_m_rad.orientation.p = euler(1);
			pobj_m_rad.orientation.r = euler(0);

			// pݒ
			opeg_svc_if.setEstimatedResult(
				model_id_to_be_tried, pobj_m_rad );

			/* ̌̍XVƏo͕ݒ */
			found_obj_count ++;
			output = out::OPE_EST_FOUND;
				// ̂𕡐悤ɂ邽߂
				// model_id_to_be_tried ͍XVȂ
		}
		else {
			// ȂC̃fIDꍇ̓fύXčĐ
			// ̏ɕKvȃp[^: őID邢̓f(Oɒׂ邩H)
			//@@@@@@@@@@@@@@@@@@@@@ ݂̓fRTCoRŒm邱Ƃ͂łȂ
			const int model_n = 6;
			if( model_id_to_be_tried < model_n ) {
				model_id_to_be_tried ++;

				// Đviprocess()ŏ́uv̏vɓj
				request_to_estimate = true;
			}
			else {
				// ȏTׂfȂꍇ́CI
				output = found_obj_count ? 
					out::OPE_EST_NOT_FOUND : out::OPE_1ST_EST_NOT_FOUND;
			}
		}
#		else //------------------------------------------------
		// 񌩂f[^L[ɓ
		queueResult();

		if( !n_result || result_q.data[5] == -102 ) {
			/* 񉽂ȂꍇiL[ɉȂĆCG[̏ꍇj */

			deleteResult();

			// ܂łɌ̂̌ɉČʂԂ(I)
			output = found_obj_count ? 
				out::OPE_EST_NOT_FOUND : out::OPE_1ST_EST_NOT_FOUND;
		}
		else {
			/* 񂢂̂̕ꍇ */
			// ̌̍XV
			found_obj_count += n_result;
			
			// 茋ʂ̐擪̂̕OPEGT[rXɑo
			dequeueResult();

			// o͕ݒ
			output = out::OPE_EST_FOUND;

		}

#		endif //-----------------------------------------------


		// I
		in_estimation = false;

	}
	
	return 0;
}


