#include "ObjectPoseEstimationGate.h"

#include "../rtcutil/rtcutil.h"
#include "../StateMachine/smutil.h"
#include <iostream>
#include <string>


using namespace std;


namespace in
{
	STATIC_CONST_STRING( OPE_EST_START );
	STATIC_CONST_STRING( OPE_EST_STOP );

	STATIC_CONST_STRING( FINISH );
}

namespace out
{
	STATIC_CONST_STRING( OPE_EST_STOPPED );
	STATIC_CONST_STRING( OPE_EST_ERROR );
}


/*=========================================================
	onExecute()
=========================================================*/
int ObjectPoseEstimationGate::process()
{
	string output;

	/* ̓`FbN */
	if( m_inputIn.isNew() ) {	
		m_inputIn.read();

		if( smutil::checkPrefix( m_input.data[0], "OPE" ) ) {
			/* 擪"OPE"̏ꍇ̓͂ɑ΂鏈Əo */
			string input = m_input.data[0];

			cout << ">> " << input << endl;

			if( input == in::OPE_EST_STOP ) {
				output = out::OPE_EST_STOPPED;
				// output = out::OPE_EST_ERROR;

			}
			else if( input == in::OPE_EST_START ) {
			
#				ifdef OPEG_USE_COMMON_IF

#				ifdef OPEG_OPERATION_WITHOUT_OPE
				if( true ) {
#				else
				/* v̔s */
				if( rtcutil::isInOperation( rec_svc ) ) {
#				endif

#					ifdef OPEG_FIND_ONE_OBJECT
					// ̐̏ꍇ̓fID=0TĂ݂
					if( !found_obj_count ) model_id_to_be_tried = 0;
#					else
					// ID^đST
					model_id_to_be_tried = 0x7FFF;
#					endif

					// v
					request_to_estimate = true;

				}
				else {
					// ̈ʒupRTCĂȂꍇ
					// G[Ƃ@ƌȂƂ@2l
					output = out::OPE_EST_ERROR;
					// Ȃꍇɂ͉ڂŌȂl
					// Kv̂ŁC̓G[Ƃ
				}
#				else

				static int dummy_counter = 0;

				switch( dummy_counter ++ ) {
					case 0:
						pose.position.x = 0.11, pose.position.y = 0.12, pose.position.z = 0.13;
						pose.orientation.y = 0.11, pose.orientation.p = 0.12, pose.orientation.r = 0.13;
						opeg_svc_if.setEstimatedResult( 1, pose );
						output = out::OPE_EST_FOUND;
						break;
					case 1:
						pose.position.x = pose.position.y = pose.position.z = 0.0;
						pose.orientation.y = pose.orientation.p = pose.orientation.r = 0.0;
						opeg_svc_if.setEstimatedResult( -1, pose );
						output = out::OPE_EST_NOT_FOUND;
						/*
						pose.position.x = 0.21, pose.position.y = 0.22, pose.position.z = 0.23;
						pose.orientation.y = 0.21, pose.orientation.p = 0.22, pose.orientation.r = 0.23;
						opeg_svc_if.setEstimatedResult( 2, pose );
						output = out::OPE_EST_FOUND;
						*/
						break;
					default:
						pose.position.x = pose.position.y = pose.position.z = 0.0;
						pose.orientation.y = pose.orientation.p = pose.orientation.r = 0.0;
						opeg_svc_if.setEstimatedResult( -1, pose );
						output = out::OPE_EST_NOT_FOUND;
						break;
				}
				
				// output = out::OPE_1ST_EST_NOT_FOUND;
				// output = out::OPE_EST_NOT_FOUND;
				// output = out::OPE_EST_ERROR;

#			endif
			}
		}
		else if( string( m_input.data[0] ) == in::FINISH ) {
			/* ď */
			activate();
				// FINISHbZ[WɑΉ鉞bZ[W HiroPnP ŒS
		}
	}

	/* v̏ */
	if( request_to_estimate )
		processRequestToEstimate( output );

	/* 蒆ȂΌʂԂĂĂȂ */
	// o͂ɏĂꍇi=G[Ȃǁjɂ́C͖
	if( in_estimation && !output.length() )
		processResult( output );

	/* o͂ło */
	if( output.length() ) {
		cout << "<< " << output << endl;

		m_output.data.length(0);
		m_output.data.length(1);
		m_output.data[0] = output.c_str();
		rtcutil::write( m_outputOut );
	}

	return 0;
}


/*=========================================================
	
=========================================================*/
int ObjectPoseEstimationGate::init()
{
	in_estimation = request_to_estimate = false;
	found_obj_count = model_id_to_be_tried = 0;

#	ifdef OPEG_FIND_ONE_OBJECT
#	else

	deleteResult();

#	endif

	return 0;
}


/*=========================================================
	ANeBx[g̏
=========================================================*/
int ObjectPoseEstimationGate::activate()
{
	in_estimation = request_to_estimate = false;
	found_obj_count = model_id_to_be_tried = 0;

#	ifdef OPEG_FIND_ONE_OBJECT
#	else

	deleteResult();

#	endif

	return 0;
}


/*=========================================================
	fANeBx[g̍ď
=========================================================*/
int ObjectPoseEstimationGate::deactivate()
{
	in_estimation = request_to_estimate = false;
	found_obj_count = model_id_to_be_tried = 0;

#	ifdef OPEG_FIND_ONE_OBJECT
#	else

	deleteResult();

#	endif

	return 0;
}


/*=========================================================
	茋ʂ̃L[
	result_q ̐茋ʃV[PXL[ɌĂ邽߂̃_~[
	ۂ̏̓f[^
=========================================================*/
int ObjectPoseEstimationGate::queueResult()
{
	result_q = m_rec_res;

	// 񌩂̂̌
	n_result = result_q.data.length() / REC_RES_N_ELEM;

	// ̑Ώ
	result_idx = 0;

	return 0;
}


/*=========================================================
	茋ʂ̃fL[
	result_q ̐茋ʃV[PXL[ɌĂ邽߂̃_~[
	ۂ̏̓f[^ϊ
=========================================================*/
int ObjectPoseEstimationGate::dequeueResult()
{
	// ̂ɑ΂ăf[^ϊ
	int obj_base_idx = result_idx * REC_RES_N_ELEM;
		
	// ɓĂꍇ̓G[Ȃł͂
	typedef opencv::cvmath::Matrix< CV_64F > M64;
	typedef opencv::cvmath::Vector< CV_64F > V64;
	using opencv::cvmath::RotationMatrixDecomposer;

	/* pݒ */
	RTC::Pose3D pobj_m_rad;

	// ]s̃Rs[
	M64 R( 3, 3 );
	V64 t_mm( 3 );

	int idx = obj_base_idx + 8;
	R(0,0) = result_q.data[idx++];
	R(0,1) = result_q.data[idx++];
	R(0,2) = result_q.data[idx++];
	t_mm(0) = result_q.data[idx++];
		
	R(1,0) = result_q.data[idx++];
	R(1,1) = result_q.data[idx++];
	R(1,2) = result_q.data[idx++];
	t_mm(1) = result_q.data[idx++];
	
	R(2,0) = result_q.data[idx++];
	R(2,1) = result_q.data[idx++];
	R(2,2) = result_q.data[idx++];
	t_mm(2) = result_q.data[idx++]; // ++͕sv

	// ]s񂩂IC[p
	RotationMatrixDecomposer< CV_64F > rmd;
	const V64 &euler = rmd.decomposeRzRyRxEuler( R );

	// i
	pobj_m_rad.position.x = 0.001*t_mm(0);
	pobj_m_rad.position.y = 0.001*t_mm(1);
	pobj_m_rad.position.z = 0.001*t_mm(2);
	// ]
	pobj_m_rad.orientation.r = euler(0);
	pobj_m_rad.orientation.p = euler(1);
	pobj_m_rad.orientation.y = euler(2);

	// OPEGT[rXɎpݒ
	opeg_svc_if.setEstimatedResult(
		result_q.data[obj_base_idx+1], pobj_m_rad );
	
	// ̂̕
	++ result_idx;

	// c̐̕Ԃ
	return n_result-result_idx;
}


/*=========================================================
	茋ʂ̍폜
	result_q ̐茋ʃV[PXL[ɌĂ邽߂̃_~[
	ۂ̏̓f[^ϊ
=========================================================*/
int ObjectPoseEstimationGate::deleteResult()
{
	n_result = result_idx = 0;
	return 0;
}