// ================================================================================== //
// Name of File				: level_set_method.cpp
// Vendor					: AISL-TUT
// Version					: 2.0.3
// ================================================================================== //

// ================================================================================== //
// Additional Algorithm :
// 1. Add function calculate_HJ()
// 2. Add function calculate_FIM()
// 3. Modify distance transform calculation
// 4. Remove some functions
// ================================================================================== //

#include "base_data.h"
#include "level_set_method.h"

#define MAX_CHAR (120)
#define MAX_FLOAT (100000000.f)

extern DWORD levelset_time1, levelset_time2, levelset_time3;
extern int levelset_num;




void calc_ramda(unsigned char **LocalMap, float **ramda);
void calc_speedFunction(float **ramda, float **speedFunc, float alpha);
//int calc_ramda1(unsigned char **LocalMap, float **ramda1);
//float calc_time_wave(CvPoint point, float **timeFunc, float **speedFunc);
//void calc_timeField(unsigned char **LocalMap, float **speedFunc, float **timeFunc, CvPoint local_subgoal);

/* inline function prototypes */
//inline void fast_search(vector<CvPoint> *trial, CvPoint heapTop, float **timeFunc, int time, CvPoint insertPoint);



void standardization_func_float(float **in_data, float** out_data)
{
	//float min = MAX_FLOAT, max = -MAX_FLOAT;
	float min = FLT_MAX, max = -FLT_MAX;
	for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(int j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			if(in_data[i][j] < min){
				min = in_data[i][j];
			}
			if(in_data[i][j] > max){
				max = in_data[i][j];
			}
		}
	}
	if(max != min){
		for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
			for(int j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
				out_data[i][j] = (in_data[i][j]-min) / (max-min);
			}
		}
	}else{
		for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
			for(int j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
				out_data[i][j] = 1.f;
			}
		}
	}
}
/*
inline void fast_search(vector<CvPoint> *trial, CvPoint heapTop, float **timeFunc, float time, CvPoint insertPoint)
{
	if(trial->size() == 0){
		trial->push_back(insertPoint);//Append
		timeFunc[insertPoint.x][insertPoint.y] = time;//Set T = 1
		return;
	}

	static vector<CvPoint>::iterator it;
	it = trial->begin();

	static int pos, max, min;
	max = (int)trial->size()-1;
	min = 0;
	pos = max>>1;
	while(1){
		if(max - min <= 1){
			if(timeFunc[(*trial)[min].x][(*trial)[min].y] <= time){//Doubtful
				pos = min;
			}else{
				pos = max;
			}
			break;
		}else if( (pos >= (int)trial->size()) || (pos <= 0) ){
			break;
		}else if(timeFunc[(*trial)[pos].x][(*trial)[pos].y] <= time){//Doubtful
			max = pos;
			pos = (min+max)>>1;
		}else{
			min = pos;
			pos = (min+max)>>1;
		}
	}
	//Insert Data
	
	if(pos >= (int)trial->size()){
		trial->push_back(insertPoint);//Append
	}else{
		trial->insert(it+pos, insertPoint);//Add to the list during the trial;
	}

	timeFunc[insertPoint.x][insertPoint.y] = time;//Set T = 1
}

int calc_ramda1(unsigned char **LocalMap, float **ramda1)
{
	//printf("start:calc_ramda1\n");
	bool obstExsist = false;//Determine whether there are obstacles
	vector<CvPoint> trial;
	//Initialization
	for(int i = 0;i < G_SELL_SIZE/GRID_SIZE;i++){
		for(int j = 0;j < G_SELL_SIZE/GRID_SIZE;j++){
			ramda1[i][j] = MAX_FLOAT;
		}
	}

	// Step1. Initialization 
	// 1.Add to the list of known, the arrival time is set to 0 
	for(int i=0;i<G_SELL_SIZE / GRID_SIZE;i++){
		for(int j=0;j<G_SELL_SIZE / GRID_SIZE;j++){
			if((LocalMap[i][j] & SFLAG) != 0){//Obstacles were still
				obstExsist = true;//The obstacles will be present
			}
			if((LocalMap[i][j] & R_AvailableFLAG) != 0){//Area were a robot can move
				if( ((i-1 >= 0) && ((LocalMap[i-1][j] & SFLAG) != 0)) || ((j-1 >= 0) && ((LocalMap[i][j-1] & SFLAG) != 0)) || ((i+1 < G_SELL_SIZE / GRID_SIZE) && ((LocalMap[i+1][j] & SFLAG) != 0)) || ((j+1 < G_SELL_SIZE / GRID_SIZE) && ((LocalMap[i][j+1] & SFLAG) != 0)) ){//One of the obstacles were still four sides
					ramda1[i][j] = 0.1f;
				}
			}
		}
	}
	if(obstExsist == false){//If there is no obstacle

		printf("There is no obstacle.\n");
		for(int i = 0;i < G_SELL_SIZE/GRID_SIZE;i++){
			for(int j = 0;j < G_SELL_SIZE/GRID_SIZE;j++){
				ramda1[i][j] = 1.f;
			}
		}
		//getchar();
		return 0;
}

	// 2.Creating a list of trial, setting an arrival time 
	for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){//y
		for(int j=0;j<G_SELL_SIZE/GRID_SIZE;j++){//x
			if(ramda1[j][i] == 0.1f){//were known
				if((i-1 >= 0) && (ramda1[j][i-1] >= MAX_FLOAT) && ((LocalMap[j][i-1] & R_AvailableFLAG) != 0)){//were far

					trial.push_back(cvPoint(j, i-1));//Add to the list of trial

					ramda1[j][i-1] = 2.f;//Set T = 1
				}
				if((j-1 >= 0) && (ramda1[j-1][i] >= MAX_FLOAT) && ((LocalMap[j-1][i] & R_AvailableFLAG) != 0)){//were far
//f
					trial.push_back(cvPoint(j-1, i));//Add to the list of trial

					ramda1[j-1][i] = 2.f;//Set T = 1
				}
				if((i+1 < G_SELL_SIZE / GRID_SIZE) && (ramda1[j][i+1] >= MAX_FLOAT) && ((LocalMap[j][i+1] & R_AvailableFLAG) != 0)){//were far

					trial.push_back(cvPoint(j, i+1));//Add to the list of trial

					ramda1[j][i+1] = 2.f;//Set T = 1
				}
				if((j+1 < G_SELL_SIZE / GRID_SIZE) && (ramda1[j+1][i] >= MAX_FLOAT) && ((LocalMap[j+1][i] & R_AvailableFLAG) != 0)){//were far

					trial.push_back(cvPoint(j+1, i));//Add to the list of trial

					ramda1[j+1][i] = 2.f;//Set T = 1
				}
			}
		}
	}

	CvPoint heapTop;
	float time;
	while( trial.size() ){//If the present trial
		// Step.2 Heap out of the top (but this time at the end) 
		heapTop = trial[trial.size()-1];
		trial.pop_back();//Remove the end
		time = ramda1[heapTop.x][heapTop.y]+1.f;
		if((heapTop.y-1 >= 0) && (ramda1[heapTop.x][heapTop.y-1] == MAX_FLOAT) && ((LocalMap[heapTop.x][heapTop.y-1] & R_AvailableFLAG) != 0)){//were far
			fast_search(&trial, heapTop, ramda1, time, cvPoint(heapTop.x, heapTop.y-1));
		}
		if((heapTop.x-1 >= 0) && (ramda1[heapTop.x-1][heapTop.y] == MAX_FLOAT) && ((LocalMap[heapTop.x-1][heapTop.y] & R_AvailableFLAG) != 0)){//were far
			fast_search(&trial, heapTop, ramda1, time, cvPoint(heapTop.x-1, heapTop.y));
		}
		if((heapTop.y+1 < G_SELL_SIZE / GRID_SIZE) && (ramda1[heapTop.x][heapTop.y+1] == MAX_FLOAT) && ((LocalMap[heapTop.x][heapTop.y+1] & R_AvailableFLAG) != 0)){//were far
			fast_search(&trial, heapTop, ramda1, time, cvPoint(heapTop.x, heapTop.y+1));
		}
		if((heapTop.x+1 < G_SELL_SIZE / GRID_SIZE) && (ramda1[heapTop.x+1][heapTop.y] == MAX_FLOAT) && ((LocalMap[heapTop.x+1][heapTop.y] & R_AvailableFLAG) != 0)){//were far
			fast_search(&trial, heapTop, ramda1, time, cvPoint(heapTop.x+1, heapTop.y));
		}
	}

	for(int i = 0;i < G_SELL_SIZE/GRID_SIZE;i++){
		for(int j = 0;j < G_SELL_SIZE/GRID_SIZE;j++){
			if( ramda1[i][j] >= MAX_FLOAT)
				ramda1[i][j] = 0.0;
		}
	}
	//printf("end:calc_ramda1\n");
	return 0;
}*/



void calc_ramda(unsigned char **LocalMap, float **ramda)
{
IplImage *func_32,*func_8;
func_32 = cvCreateImage (cvSize (G_SELL_SIZE/GRID_SIZE, G_SELL_SIZE/GRID_SIZE), IPL_DEPTH_32F, 1);
func_8 = cvCreateImage(cvSize(G_SELL_SIZE/GRID_SIZE, G_SELL_SIZE/GRID_SIZE), IPL_DEPTH_8U, 1);

for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(int j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			if((LocalMap[i][j] & (R_AvailableFLAG)) != 0)cvSetReal2D(func_8, i, j, 255);
			else cvSetReal2D(func_8, i, j, 0);
		}
}

cvDistTransform ( func_8 , func_32 , CV_DIST_L2 , 5 , NULL , NULL );
cvNormalize(func_32, func_8, 0.0, 255.0, CV_MINMAX, NULL);

for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(int j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			ramda[i][j]=cvGetReal2D(func_32,i,j);
		}
}

cvReleaseImage(&func_32);
cvReleaseImage(&func_8);

}

void calc_speedFunction(float **ramda, float **speedFunc, float alpha)
{
	for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(int j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			if(ramda[i][j] == 0.f){
				speedFunc[i][j] = 0.f;
			}else{
				//speedFunc[i][j] = exp(alpha*ramda[i][j]);
				//speedFunc[i][j] = pow(100, ramda[i][j]);
				//speedFunc[i][j] = ramda[i][j];
				speedFunc[i][j] = 1;
				if(speedFunc[i][j] < 0.01f) speedFunc[i][j] = 0.01f;
			}
		}
	}
}

void calc_dt(unsigned char **LocalMap, IplImage *func_32)
{
IplImage *func_8;
func_8 = cvCreateImage(cvSize(G_SELL_SIZE/GRID_SIZE, G_SELL_SIZE/GRID_SIZE), IPL_DEPTH_8U, 1);

for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(int j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			if((LocalMap[i][j] & (R_AvailableFLAG)) != 0)cvSetReal2D(func_8, i, j, 255);
			else cvSetReal2D(func_8, i, j, 0);
		}
}

cvDistTransform ( func_8 , func_32 , CV_DIST_L2 , 5 , NULL , NULL );
cvNormalize(func_32, func_8, 0.0, 255.0, CV_MINMAX, NULL);

cvReleaseImage(&func_8);

}

/*float calc_time_wave(CvPoint point, float **timeFunc, float **speedFunc)
{
	float time = 0.f, max_h=0.f, max_v=0.f;
	float tmp;

	if(point.x -1 >= 0){
		tmp = timeFunc[point.x][point.y] - timeFunc[point.x-1][point.y];
		if(tmp>max_h){
			max_h = tmp;
		}
	}
	if(point.x+1 < G_SELL_SIZE/GRID_SIZE){
		tmp = timeFunc[point.x][point.y] - timeFunc[point.x+1][point.y];
		if(tmp>max_h){
			max_h = tmp;
		}
	}
	if(point.y-1 >= 0){
		tmp = timeFunc[point.x][point.y] - timeFunc[point.x][point.y-1];
		if(tmp>max_v){
			max_v = tmp;
		}
	}
	if(point.y+1 < G_SELL_SIZE/GRID_SIZE){
		tmp = timeFunc[point.x][point.y] - timeFunc[point.x][point.y+1];
		if(tmp>max_v){
			max_v = tmp;
		}
	}

	if((max_h == 0.0) && (max_v == 0.0)){
		printf("ERROR! max_h=0.0,max_v = 0.0\n");
		tmp = timeFunc[point.x][point.y] - timeFunc[point.x-1][point.y];
		printf("%.2f\n", tmp);
		printf("timeFunc[point.x][point.y]=%f\n", timeFunc[point.x][point.y]);
		printf("timeFunc[point.x-1][point.y]=%f\n", timeFunc[point.x-1][point.y]);
		tmp = timeFunc[point.x][point.y] - timeFunc[point.x+1][point.y];
		printf("%.8f\n", tmp);
		tmp = timeFunc[point.x][point.y] - timeFunc[point.x][point.y-1];
		printf("%.8f\n", tmp);
		tmp = timeFunc[point.x][point.y] - timeFunc[point.x][point.y+1];
		printf("%.8f\n", tmp);
		getchar();
		return -1;
	}else if(max_h == 0.0){
		return (max(0, min(MAX_FLOAT-0.125f, 1/speedFunc[point.x][point.y] - max_v + MAX_FLOAT)));
	}else if(max_v == 0.0){
		return (max(0, min(MAX_FLOAT-0.125f, 1/speedFunc[point.x][point.y] - max_h + MAX_FLOAT)));
	}else{
		float D, E;
		D = 2*MAX_FLOAT-max_v-max_h;
		E = POW(MAX_FLOAT-max_v) + POW(MAX_FLOAT-max_h) - POW(1/speedFunc[point.x][point.y]);
		if(POW(D)-2*E < 0){//I do not want to happen is really a branch.
			if(max_v < max_h)//(MAX_FLOAT - max_v > MAX_FLOAT - max_h)
				return (max(0, min(MAX_FLOAT-0.125f, 1/speedFunc[point.x][point.y] - max_v + MAX_FLOAT)));
			else 
				return (max(0, min(MAX_FLOAT-0.125f, 1/speedFunc[point.x][point.y] - max_h + MAX_FLOAT)));
		}
		time = (float)((D+sqrt(POW(D)-2*E))/2.0);
		return max(0, min(MAX_FLOAT-0.125f, time));
	}
	return time;
}

void calc_timeField(unsigned char **LocalMap, float **speedFunc, float **timeFunc, CvPoint local_subgoal)
{
	vector<CvPoint> trial;
	//** If initialization time 
	for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(int j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			timeFunc[i][j] = MAX_FLOAT;
		}
	}

	//** Set t = 0 
	timeFunc[local_subgoal.x][local_subgoal.y] = 0.f;
	// 2.Creating a list of trial and set the arrival time 
	if((local_subgoal.y-1 >= 0) && ((LocalMap[local_subgoal.x][local_subgoal.y-1] & R_AvailableFLAG) != 0) && (speedFunc[local_subgoal.x][local_subgoal.y-1] != 0.f)){//were far
		trial.push_back(cvPoint(local_subgoal.x, local_subgoal.y-1));//Add to the list of trial
		//printf("speedFunc[local_subgoal.x][local_subgoal.y-1] = %f\n", speedFunc[local_subgoal.x][local_subgoal.y-1]);
		timeFunc[local_subgoal.x][local_subgoal.y-1] = 1.f/speedFunc[local_subgoal.x][local_subgoal.y-1];
	}
	if((local_subgoal.x-1 >= 0) && ((LocalMap[local_subgoal.x-1][local_subgoal.y] & R_AvailableFLAG) != 0) && (speedFunc[local_subgoal.x-1][local_subgoal.y] != 0.f)){//were far
		trial.push_back(cvPoint(local_subgoal.x-1, local_subgoal.y));//Add to the list of trial
		//printf("speedFunc[local_subgoal.x-1][local_subgoal.y] = %f\n", speedFunc[local_subgoal.x-1][local_subgoal.y]);
		timeFunc[local_subgoal.x-1][local_subgoal.y] = 1.f/speedFunc[local_subgoal.x-1][local_subgoal.y];
	}
	if((local_subgoal.y+1 < G_SELL_SIZE / GRID_SIZE) && ((LocalMap[local_subgoal.x][local_subgoal.y+1] & R_AvailableFLAG) != 0) && (speedFunc[local_subgoal.x][local_subgoal.y+1] != 0.f)){//were far
		trial.push_back(cvPoint(local_subgoal.x, local_subgoal.y+1));//Add to the list of trial
		//printf("speedFunc[local_subgoal.x][local_subgoal.y+1] = %f\n", speedFunc[local_subgoal.x][local_subgoal.y+1]);
		timeFunc[local_subgoal.x][local_subgoal.y+1] = 1.f/speedFunc[local_subgoal.x][local_subgoal.y+1];
	}
	if((local_subgoal.x+1 < G_SELL_SIZE / GRID_SIZE) && ((LocalMap[local_subgoal.x+1][local_subgoal.y] & R_AvailableFLAG) != 0) && (speedFunc[local_subgoal.x+1][local_subgoal.y] != 0.f)){//were far
		trial.push_back(cvPoint(local_subgoal.x+1, local_subgoal.y));//Add to the list of trial
		//printf("speedFunc[local_subgoal.x+1][local_subgoal.y] = %f\n", speedFunc[local_subgoal.x+1][local_subgoal.y]);
		timeFunc[local_subgoal.x+1][local_subgoal.y] = 1.f/speedFunc[local_subgoal.x+1][local_subgoal.y];
	}

	// Step.2 
	// If the arrival time of the wave generated 
	CvPoint heapTop;
	while( trial.size() ){//If the present trialv
		// Step.2 Heap out of the top (but this time at the end) 
		heapTop = trial[trial.size()-1];
		trial.pop_back();//Remove the end
		if((heapTop.y-1 >= 0) && (timeFunc[heapTop.x][heapTop.y-1] == MAX_FLOAT) && ((LocalMap[heapTop.x][heapTop.y-1] & R_AvailableFLAG) != 0) && (speedFunc[heapTop.x][heapTop.y-1] != 0.f)){//were far
			timeFunc[heapTop.x][heapTop.y-1] = calc_time_wave(cvPoint(heapTop.x, heapTop.y-1), timeFunc, speedFunc);
			fast_search(&trial, heapTop, timeFunc, timeFunc[heapTop.x][heapTop.y-1], cvPoint(heapTop.x, heapTop.y-1));
		}
		if((heapTop.x-1 >= 0) && (timeFunc[heapTop.x-1][heapTop.y] == MAX_FLOAT) && ((LocalMap[heapTop.x-1][heapTop.y] & R_AvailableFLAG) != 0) && (speedFunc[heapTop.x-1][heapTop.y] != 0.f)){//were far
			timeFunc[heapTop.x-1][heapTop.y] = calc_time_wave(cvPoint(heapTop.x-1, heapTop.y), timeFunc, speedFunc);
			fast_search(&trial, heapTop, timeFunc, timeFunc[heapTop.x-1][heapTop.y], cvPoint(heapTop.x-1, heapTop.y));
		}
		if((heapTop.y+1 < G_SELL_SIZE / GRID_SIZE) && (timeFunc[heapTop.x][heapTop.y+1] == MAX_FLOAT) && ((LocalMap[heapTop.x][heapTop.y+1] & R_AvailableFLAG) != 0) && (speedFunc[heapTop.x][heapTop.y+1] != 0.f)){//were far
			timeFunc[heapTop.x][heapTop.y+1] = calc_time_wave(cvPoint(heapTop.x, heapTop.y+1), timeFunc, speedFunc);
			fast_search(&trial, heapTop, timeFunc, timeFunc[heapTop.x][heapTop.y+1], cvPoint(heapTop.x, heapTop.y+1));
		}
		if((heapTop.x+1 < G_SELL_SIZE / GRID_SIZE) && (timeFunc[heapTop.x+1][heapTop.y] == MAX_FLOAT) && ((LocalMap[heapTop.x+1][heapTop.y] & R_AvailableFLAG) != 0) && (speedFunc[heapTop.x+1][heapTop.y] != 0.f)){//were far
			timeFunc[heapTop.x+1][heapTop.y] = calc_time_wave(cvPoint(heapTop.x+1, heapTop.y), timeFunc, speedFunc);
			fast_search(&trial, heapTop, timeFunc, timeFunc[heapTop.x+1][heapTop.y], cvPoint(heapTop.x+1, heapTop.y));
		}
	}

	// Post-processing 
	for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(int j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			if(timeFunc[i][j] == MAX_FLOAT){
				timeFunc[i][j] = 0.0;
			}
		}
	}
}*/

float calculate_HJ(CvPoint point,float **timeFunc, float **speedFunc)
{
static float min_x=0.f,min_y=0.f;
static float temp,b,c,f;

if(point.x -1 >= 0){
		temp = timeFunc[point.x-1][point.y];
		min_x = temp;
		
	}
	if(point.x+1 < G_SELL_SIZE/GRID_SIZE){
		temp = timeFunc[point.x+1][point.y];
		if(temp<min_x){
			min_x = temp;
		}
	}
	if(point.y-1 >= 0){
		temp = timeFunc[point.x][point.y-1];
		min_y = temp;
		}
	if(point.y+1 < G_SELL_SIZE/GRID_SIZE){
		temp = timeFunc[point.x][point.y+1];
		if(temp<min_y){
			min_y = temp;
		}
	}

c=min(min_x,min_y);
b=max(min_x,min_y);
f=speedFunc[point.x][point.y];

float u=(float)(c+1.0/f);
if(u<=b)return u;
//if((-b*b-c*c+2.0*b*c+2.0/(f*f))<0)u=c+1.0/f;
else u=(float)((b+c+sqrt(-b*b-c*c+2.0*b*c+2.0/(f*f)))/2.0);
return u;

}

void calculate_FIM(unsigned char **LocalMap2, float **speedFunc, float **timeFunc, CvPoint local_subgoal)
{

vector<CvPoint> trial;
static float temp1,temp2,temp3,maxi=0,count_max=0;
static CvPoint point,point2;
static bool condition[G_SELL_SIZE/GRID_SIZE][G_SELL_SIZE/GRID_SIZE];
static unsigned char LocalMap[G_SELL_SIZE/GRID_SIZE][G_SELL_SIZE/GRID_SIZE];


for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(int j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			timeFunc[i][j] = MAX_FLOAT;
			condition[i][j]=false;
			if(i==0||j==0)LocalMap[i][j]=UnKnown_FLAG;
			else LocalMap[i][j]=LocalMap2[i][j];
		}
	}



timeFunc[local_subgoal.x][local_subgoal.y] = 0.f;
if((local_subgoal.x-1>=0) && ((LocalMap[local_subgoal.x-1][local_subgoal.y] & R_AvailableFLAG) != 0))
{trial.push_back(cvPoint(local_subgoal.x-1, local_subgoal.y));condition[local_subgoal.x-1][local_subgoal.y]=true;}
if((local_subgoal.y-1>=0) && ((LocalMap[local_subgoal.x][local_subgoal.y-1] & R_AvailableFLAG) != 0))
{trial.push_back(cvPoint(local_subgoal.x, local_subgoal.y-1));condition[local_subgoal.x][local_subgoal.y-1]=true;}
if((local_subgoal.x+1< G_SELL_SIZE/GRID_SIZE) && ((LocalMap[local_subgoal.x+1][local_subgoal.y] & R_AvailableFLAG) != 0))
{trial.push_back(cvPoint(local_subgoal.x+1, local_subgoal.y));condition[local_subgoal.x+1][local_subgoal.y]=true;}
if((local_subgoal.y+1< G_SELL_SIZE/GRID_SIZE) && ((LocalMap[local_subgoal.x][local_subgoal.y+1] & R_AvailableFLAG) != 0))
{trial.push_back(cvPoint(local_subgoal.x, local_subgoal.y+1));condition[local_subgoal.x][local_subgoal.y+1]=true;}

//printf("init FIM OK %d \n",trial.size());

while( trial.size()){

for(int i=0;i<(int)trial.size();i++)
{
point=trial[i];
if(condition[point.x][point.y]==true)
{
temp1=calculate_HJ(point,timeFunc,speedFunc);
//temp1=calc_time_wave(trial[i],timeFunc,speedFunc);
temp2=timeFunc[point.x][point.y];
if(temp2>temp1)timeFunc[point.x][point.y]=temp1;
if(temp1>maxi)maxi=temp1;if(trial.size()>(unsigned int)count_max)count_max=trial.size();
temp3=temp2-temp1;
if(temp3<0)temp3=-temp3;
if(temp3<0.1f)
{
	

	if(point.x-1>=0 && ((LocalMap[point.x-1][point.y] & R_AvailableFLAG) != 0) && condition[point.x-1][point.y]==false)
	{
	point2.x=point.x-1;
	point2.y=point.y;
		temp1=calculate_HJ(point2,timeFunc,speedFunc);
		//temp1=calc_time_wave(point,timeFunc,speedFunc);
		temp2=timeFunc[point2.x][point2.y];		
		if(temp2>temp1){timeFunc[point2.x][point2.y]=temp1;trial.push_back(point2);condition[point2.x][point2.y]=true;}
	
	}

	if(point.x+1< G_SELL_SIZE/GRID_SIZE && ((LocalMap[point.x+1][point.y] & R_AvailableFLAG) != 0) && condition[point.x+1][point.y]==false)
	{
	point2.x=point.x+1;
	point2.y=point.y;
	
		temp1=calculate_HJ(point2,timeFunc,speedFunc);
		//temp1=calc_time_wave(point,timeFunc,speedFunc);
		temp2=timeFunc[point2.x][point2.y];		
		if(temp2>temp1){timeFunc[point2.x][point2.y]=temp1;trial.push_back(point2);condition[point2.x][point2.y]=true;}
	
	}

	if(point.y-1>=0 && ((LocalMap[point.x][point.y-1] & R_AvailableFLAG) != 0) && condition[point.x][point.y-1]==false)
	{
	point2.x=trial[i].x;
	point2.y=trial[i].y-1;
	
		temp1=calculate_HJ(point2,timeFunc,speedFunc);
		//temp1=calc_time_wave(point,timeFunc,speedFunc);
		temp2=timeFunc[point2.x][point2.y];		
		if(temp2>temp1){timeFunc[point2.x][point2.y]=temp1;trial.push_back(point2);condition[point2.x][point2.y]=true;}
	
	}

	if(point.y+1< G_SELL_SIZE/GRID_SIZE && ((LocalMap[point.x][point.y+1] & R_AvailableFLAG) != 0) && condition[point.x][point.y+1]==false)
	{
	point2.x=point.x;
	point2.y=point.y+1;
	
		temp1=calculate_HJ(point2,timeFunc,speedFunc);
		//temp1=calc_time_wave(point,timeFunc,speedFunc);
		temp2=timeFunc[point2.x][point2.y];		
		if(temp2>temp1){timeFunc[point2.x][point2.y]=temp1;trial.push_back(point2);condition[point2.x][point2.y]=true;}
	
	}
	condition[point.x][point.y]=false;
	trial.erase(trial.begin()+i);
	--i;
}
}

}
//printf("FIM calculating %d \n",trial.size());
}

//printf("maxi %f count %f\n",maxi,count_max);

for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(int j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			if(timeFunc[i][j] == MAX_FLOAT )timeFunc[i][j] =0.f;
		}
	}

}
	
/* Distance transform */
unsigned char target_root(unsigned char **LocalMap, IplImage *Gauss_f32, CvPoint local_subgoal)
{
	DWORD levelset_time_tmp;
	//static float **ramda1=NULL;
	static float **ramda=NULL;

	static float **speedFunc=NULL, **timeFunc=NULL;
	static float alpha = 0.8f;

	//time_sum.QuadPart = 0;
	/*** Partitioning ***/
	/*if(ramda1 == NULL){
		ramda1 = (float **)calloc(G_SELL_SIZE/GRID_SIZE, sizeof(float *));
		for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
			ramda1[i] = (float *)calloc(G_SELL_SIZE/GRID_SIZE, sizeof(float));
		}

	}
	*/

	if(ramda == NULL){
		ramda = (float **)calloc(G_SELL_SIZE/GRID_SIZE, sizeof(float *));
		for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
			ramda[i] = (float *)calloc(G_SELL_SIZE/GRID_SIZE, sizeof(float));
		}

	}
	if(speedFunc == NULL){
		speedFunc = (float **)calloc(G_SELL_SIZE/GRID_SIZE, sizeof(float *));
		for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
			speedFunc[i] = (float *)calloc(G_SELL_SIZE/GRID_SIZE, sizeof(float));
		}

	}
	if(timeFunc == NULL){
		timeFunc = (float **)calloc(G_SELL_SIZE/GRID_SIZE, sizeof(float *));
		for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
			timeFunc[i] = (float *)calloc(G_SELL_SIZE/GRID_SIZE, sizeof(float));
		}

	}

	/*** ramda1 Initialization  ***/
	/*for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(int j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			ramda1[i][j] = 0.f;
		}
	}*/

	/* ramda1 Calculation  */
	levelset_time_tmp = timeGetTime();
	int flag;

	//flag = calc_ramda1(LocalMap, ramda1);
	/*if(flag == -1){//Calculation error

		return CALCULATION_ERROR;
	}*/
	calc_ramda(LocalMap,ramda);

	levelset_time1 += timeGetTime() - levelset_time_tmp;
	
	/*** ramda Normalization  ***/
	//standardization_func_float(ramda1, ramda);
	standardization_func_float(ramda, ramda);

	/*** Calculation SPEED FUNCTION ***/
	calc_speedFunction(ramda, speedFunc, alpha);

	standardization_func_float(speedFunc, speedFunc);


	/*** generation time of arrival ***/
	levelset_time_tmp = timeGetTime();
	//calc_timeField(LocalMap, speedFunc, timeFunc, local_subgoal);
	calculate_FIM(LocalMap,speedFunc,timeFunc,local_subgoal);

	levelset_time2 += timeGetTime() - levelset_time_tmp;
	levelset_time_tmp = timeGetTime();
	/*** Normalization timeFunc ***/

	standardization_func_float(timeFunc, timeFunc);



	/* Inversion operation */ // Now do not invers, because it will rise error
#if 1
	for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(int j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			if(timeFunc[i][j] != 0.f){
				//timeFunc[j][i] = exp(1.f - timeFunc[j][i]);
				timeFunc[i][j] = 1.f - timeFunc[i][j];
			}
		}
	}
	timeFunc[local_subgoal.x][local_subgoal.y] = 1.f;
#endif
	
	/*** Registered Gaussian image ***/
	for(int i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(int j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			cvSetReal2D(Gauss_f32, i,j, timeFunc[i][j]*1000.f);
		}
	}

	levelset_time3 += timeGetTime() - levelset_time_tmp;
	
	
	return 0;
}
