// ================================================================================== //
// Name of File				: obst_info.h
// Vendor					: AISL-TUT
// Version					: 2.0.3
// ================================================================================== //

#ifndef _OBST_INFO
#define _OBST_INFO
#include "base_data.h"
//#include <opencv/cv.h>
//#include <opencv/cxcore.h>
//#include <opencv/highgui.h>
#define VERTEX_MAX_NUM	(15+1)//What can be acceptable to the square. The maximum number of vertices.

/** Types of obstacles**/
#define DYNAMIC			(TRUE)
#define STATIC			(FALSE)

/** Edge type**/
#define HORIZONTAL		(0)
#define VERTICAL		(1)
#define SLOPE			(2)

/** Number-impaired migration **/
#define DYNAMIC_NUM		(0+1)
/** Number-static failure **/
#define STATIC_NUM		(10+1)
#define R_OBJE			M_OBJE

class OBJECT{
protected:
	
public:
	OBJECT *next , *pre;
	Position CPosition;
	CvPoint LocalCPosition;
	float direction;
	int width , height;
	int id;
	unsigned char **original_polygon;
	unsigned char **optional_polygon;
	
	//OBJECT(int size_x , int size_y , float direction = 0);//Constructor. Field preparation. Also specify the angle.
	void Revolution(float direction);//Rotating field. In fact the only change direction.
	void SetPolygonField();
	int  SetOptionalPolygon(int id);
	int  SetOptionalPolygon();
	void DeleteObje();
	void DeleteObje(int id);
	OBJECT* SearchIDAddress(int id);//Address Search
	void SetPosition(float x , float y , int id);//Center coordinate setting
	void SetPosition(float x , float y);//Center coordinate setting
};

class M_OBJE : public OBJECT{//I do not like the id is put in order from number 1. Moving object. Also I'm using this robot.
public:
	float velocity , omega, radius;
	
	M_OBJE(int width , int height , int id = 1 , float direction = 0 , float velocity = 0 , float omega = 0, float radius =0);//Constructor
	M_OBJE();//Constructor
	~M_OBJE();//Destructor
	/*Specific functions*/
	void construct(int width , int height , int id = 1 , float direction = 0 , float velocity = 0 , float omega = 0, float radius =0);//Instead of Constructors
	void SetCircle(int r , unsigned char FLAG_TYPE = MFLAG);
	int MakeMObje(int width , int height , float direction = 0 , float velocity = 0 , float omega = 0, float radius =0);//id return values
};

class S_OBJE : public OBJECT{//static
public:
	bool renew_flag;
	S_OBJE(int width , int height , int id = 1 , float direction = 0);//Constructor
	~S_OBJE();//Destructor
	/*Specific functions*/
	void SetRectangle(CvRect rect);
	int MakeSObje(int width , int height , float direction = 0);//id return values
};
/***** Prototype declaration *****/
void MobjeBuilder(M_OBJE **move_obje , M_OBJE *array_Mobje[OBJECT_MAX_NUM] , short *NumOfMobje , RECEIVE_OBST_DATA *data_people , unsigned char **LocalMap , DATA_LOGGER robot_data , short m_counter);

Position Convert_Local2Global(CvPoint local_map_position , R_OBJE *robot);
CvPoint Convert_Global2Local(R_OBJE *robot , float *xg);
CvPoint Convert_Global2Local(R_OBJE *robot , Position pose);
CvPoint Convert_Global2Local(Position robot_position , float robot_direction , Position pose);
Position Convert_Local2Global(CvPoint local_map_position , Position robot_position , float robot_direction);

unsigned short InsideOfStaticObstacle(R_OBJE *robot , unsigned char **LocalMap , DATA_LOGGER robot_data);//Collision detection
#endif