#pragma once


#include "../../system/socket/socket.h"
#include "../../system/thread/thread.h"
#include "../../system/crtsec/crtsec.h"
#include "../../system/event/event.h"


class HTTPC
{
private:
	sys::Thread thread;
	sys::TCPSocket server, to_client;

	sys::CriticalSection cs;
	sys::Event data_posted, data_updated;
	
	std::string request, response;
	std::vector< char > buf;

	int templ_html_len;
	char *templ_html;
	
	std::string state, next_status, input_tags;
	std::string posted_data;
	bool pushing;

	bool is_initialized;
	bool kill_switch;

public:
	HTTPC();
	~HTTPC();

	int initialize( unsigned short tcp_port_no, const char *template_html_path );
	int finalize();

	void postDataUpdated();
	bool waitForPOST();

	void getHTMLParameter( std::string &state, std::string &next_status );
	void setHTMLParameter(
		const std::string &state,
		const std::vector< std::string > &next_status,
		const std::vector< bool > &disabled_status );
	
	void getPostedData( std::string &posted );
	void push() { pushing = true; }
	

private:
	static unsigned int __stdcall process( void *httpc_vp );
	
	int receiveRequest();
	int createHTML();
	
	int sendResponse();

};