#pragma once


#include <string>


class IdStrTaple
{
protected:
	const int id;
	const std::string str;

public:
	IdStrTaple() : id(0), str("") {}
	IdStrTaple( int identifier, const std::string &string) : id(identifier), str(string) {}
	virtual ~IdStrTaple() {}

public:
	int getId() const { return id; }
	const std::string &getStr() const { return str; }
};


class HTTPMethod : public IdStrTaple
{
public:
	HTTPMethod( int id, const std::string &name ) : IdStrTaple(id, name) {}
	~HTTPMethod() {}

public:
	const std::string &getName() const {	return str; }
};


class HTTPVersion : public IdStrTaple
{
public:
	HTTPVersion() : IdStrTaple() {}
	HTTPVersion( int id, const std::string &str ) : IdStrTaple(id, str) {}
	~HTTPVersion() {}
};


class HTTPResponse : public IdStrTaple
{
public:
	HTTPResponse() : IdStrTaple() {}
	HTTPResponse( int status_code, const std::string &message ) : IdStrTaple(status_code, message) {}
	~HTTPResponse() {}

public:
	int getStatusCode() const { return id; }
	const std::string &getStatusMessage() const {	return str; }
	
};

class HTTPHeader : public IdStrTaple
{
public:
	HTTPHeader()
		: IdStrTaple()
	{
	}

	HTTPHeader(int id, const std::string &header)
		: IdStrTaple(id, header)
	{
	}

	~HTTPHeader()
	{
	}

public:
	inline const std::string &getHeader() const
	{
		return str;
	}
};

