#pragma once


#include <string>


#if WXDEBUG == 1
#include <iostream>
using std::cout;	using std::cerr;	using std::endl;
#endif


class MIME
{
//=====================================
//	Public constants
//=====================================
public:
	enum id_t
	{
		MIM_ID_HTML = 0,
		MIM_ID_HTM,
		MIM_ID_XML,
		MIM_ID_TXT,
		MIM_ID_CSV,
		MIM_ID_PNG,
		MIM_ID_JPG,
		MIM_ID_JPEG,
		MIM_ID_URLENCODED,
		MIM_ID_UNKNOWN
	};
	
	static const int MIME_N = MIM_ID_UNKNOWN + 1;

//=====================================
//	Private type
//=====================================
public:
	/* struct of mime */
	struct entry_t
	{
		std::string suffix;
		std::string description;
	};

	static const entry_t ENTRY[MIME_N];

//=====================================
//	Public functions
//=====================================
public:	// Constructors or destructors
	MIME()
	{
#if WXDEBUG == 1
		cerr << "MIME()" << endl;
#endif
	}

	~MIME()
	{
#if WXDEBUG == 1
		cerr << "~MIME()" << endl;
#endif
	}

public:
	static const std::string &get(const std::string &path, int *id = NULL);
	static const std::string &get(int id);

};
