//=========================================================
// Junichi Sugiyama @ AISL.TUT
// --------------------------------------------------------
// ikfast utility header file
//  for calling functions in the namespace ikfast
// --------------------------------------------------------
// ikfast::hiro::larm/rarmōE̓֐𕪂悤DLL
// 쐬CЕNȂ悤Ȃ̂ŁC̃wb_
// t@Cikfast::hiro::rarm/larm̖OԂĂ
// D
// inline Ŋ֐錾Ă̂́Ct@C̃CN
// [hɓ̃̕IuWFNgȂ悤
// ɂ邽߁D
//=========================================================


#pragma once


#include "ik-hiro-larm.h"
#include "ik-hiro-rarm.h"


#if defined( IKUTIL_LINK_LIBS_VC90 )
#pragma comment( lib, "ik-hiro-larm-vc90-win71.lib" )
#pragma comment( lib, "ik-hiro-rarm-vc90-win71.lib" )
#elif defined( IKUTIL_LINK_LIBS_VC100 )
#pragma comment( lib, "ik-hiro-larm-vc100-win71.lib" )
#pragma comment( lib, "ik-hiro-rarm-vc100-win71.lib" )
#else
#endif


namespace ikfast
{

	
	/* ͈͍\ */
	struct range_t {
		double max_rad, min_rad;
	public:
		bool isIn( double angle_rad ) {
			return ( min_rad <= angle_rad && angle_rad <= max_rad );
		}
	};

	
	namespace hiro
	{
	
		/**
			`FbN
		*/
		inline bool filter(
			const std::vector< IKSolution >& solutions,		// @ IKxN^
			range_t *ranges,															// 
			std::vector< IKReal > &sol,										// @ IKpꎞ̈
			std::vector< int > &valid_idx )				// @ ̉CfbNX
		{
			valid_idx.clear();

			bool will_be_registered;

			for( size_t sol_idx = 0; sol_idx < solutions.size(); ++sol_idx ) {

				solutions[sol_idx].GetSolution( &sol[0], NULL );
			
				will_be_registered = true;

				// ͈̓`FbN
				for( std::size_t jnt_idx = 0; jnt_idx < sol.size(); ++jnt_idx ) {
					if( !ranges[jnt_idx].isIn( sol[jnt_idx] ) ) {
						will_be_registered = false; break;
					}
				}

				// ͈̓`FbNɍî͓o^
				if( will_be_registered ) valid_idx.push_back( int(sol_idx) );
			}

			return valid_idx.size() ? true : false;
		}
	
		namespace larm
		{
			// wrapper functins to call *L from namespace larm
			inline void fk(const IKReal* j, IKReal* eetrans, IKReal* eerot) { fkL( j, eetrans, eerot ); }
			inline int getNumFreeParameters() { return getNumFreeParametersL();	}
			inline int* getFreeParameters() { return getFreeParametersL(); }
			inline int getNumJoints() { return getNumJointsL(); }
			inline int getIKRealSize() { return getIKRealSizeL(); }
			inline int getIKType() { return getIKTypeL(); }
			inline bool ik(const IKReal* eetrans, const IKReal* eerot, const IKReal* pfree, std::vector<IKSolution>& vsolutions)
			{	return ikL(eetrans, eerot, pfree, vsolutions); }
			inline const char* getKinematicsHash(){ return getKinematicsHashL(); }

			/**
				r`FbN
			*/
			inline bool filter(
				const std::vector< IKSolution >& solutions,	// @ IK
				std::vector< int > &valid_indices )			// @ ̉CfbNX
			{
				static const double DEG2RAD = IKPI / 180.0;
		
				/* ͈ */
				struct range_t ranges[6] = {
					{+ 85*DEG2RAD, - 85*DEG2RAD}, {+115*DEG2RAD, -175*DEG2RAD},
					{+  0*DEG2RAD, -155*DEG2RAD}, {+190*DEG2RAD, -130*DEG2RAD}, 
					{+ 95*DEG2RAD, - 95*DEG2RAD}, {+125*DEG2RAD, -125*DEG2RAD}
				};
		
				/* ֐ߐ`FbN */
				if( getNumJoints() != 6 ) {
					fprintf( stderr, "ikfast::hiro::larm::filter(): # joints not match." );
					return false;
				}

				std::vector< IKReal > sol( getNumJoints() );
				return hiro::filter( solutions, ranges, sol, valid_indices );
			}
		} // end of "namespace larm"

		namespace rarm 
		{
			// wrapper functins to call *L from namespace rarm
			inline void fk(const IKReal* j, IKReal* eetrans, IKReal* eerot) { fkR( j, eetrans, eerot ); }
			inline int getNumFreeParameters() { return getNumFreeParametersR();	}
			inline int* getFreeParameters() { return getFreeParametersR(); }
			inline int getNumJoints() { return getNumJointsR(); }
			inline int getIKRealSize() { return getIKRealSizeR(); }
			inline int getIKType() { return getIKTypeR(); }
			inline bool ik(const IKReal* eetrans, const IKReal* eerot, const IKReal* pfree, std::vector<IKSolution>& vsolutions)
			{	return ikR(eetrans, eerot, pfree, vsolutions); }
			inline const char* getKinematicsHash(){ return getKinematicsHashR(); }

			/**
				Er`FbN
			*/
			inline bool filter(
				const std::vector< IKSolution >& solutions,	// @ IK
				std::vector< int > &valid_indices )			// @ ̉CfbNX
			{
				static const double DEG2RAD = IKPI / 180.0;
		
				/* ͈ */
				struct range_t ranges[6] = {
					{+ 85*DEG2RAD, - 85*DEG2RAD}, {+115*DEG2RAD, -175*DEG2RAD},
					{+  0*DEG2RAD, -155*DEG2RAD}, {+130*DEG2RAD, -190*DEG2RAD}, 
					{+ 95*DEG2RAD, - 95*DEG2RAD}, {+125*DEG2RAD, -125*DEG2RAD}
				};
		
				/* ֐ߐ`FbN */
				if( getNumJoints() != 6 ) {
					fprintf( stderr, "ikfast::hiro::rarm::filter(): # joints not match." );
					return false;
				}

				std::vector< IKReal > sol( getNumJoints() );
				return hiro::filter( solutions, ranges, sol, valid_indices );
			}

		} // end of "namespace rarm"
	} // end of "namespace hiro"

} // end of "namespace ikfast"
