#include "../../httpc/httpc/httpc.h"
#include "state-machine.h"


using namespace state_machine;
using namespace std;


int main()
{
	sys::SocketBase::initializeWinSock();
	StateMachine state_machine;
	HTTPC httpc;

	if( state_machine.initialize( "../../../../VSData/scenario.xml" ) )
		return sys::returnByError< int >( EXIT_FAILURE, "", true );
	state_machine.print();
	
	httpc.initialize( 8080, "../../../../VSData/templ.html" );

	string state = state_machine.getCurrentState().getName();
	vector< string > next_status;
	vector< bool > disabled_status;
	const vector< StateMachine::State::transition_t > 
		&trans_tbl = state_machine.getCurrentState().getTransitionTable();
	vector< StateMachine::State::transition_t >::const_iterator cit;
	for( cit = trans_tbl.cbegin();
		cit != trans_tbl.cend();
		++ cit )
	{
		next_status.push_back( cit->next->getName() );
		disabled_status.push_back( cit->on_manual );
	}
	httpc.setHTMLParameter( state, next_status, disabled_status );
	
	string input;
	
	// ]̑Jڐ悩Kvȓ͂߂ďԑJڂs
	int state_count = 0;
	while( state_machine.getCurrentState().getName() != "F" ) {

		if( httpc.waitForPOST() ) {
			/* POST ꍇ */
			
			// POSTꂽf[^̎ԕv͂擾
			string posted_data;
			httpc.getPostedData( posted_data );
			if( posted_data == "state=Abort" ) {
				input = "";
				state_machine.transitionIntoError();
			}
			else {
				int idx = state_machine.getRequiredInput( posted_data.substr( strlen("state=") ), input );
				cout << idx << " " << posted_data.substr( strlen("state=") ) << endl;
				if( idx == -1 )
					input = "";
				// v͂𗘗pĎԂ֏ԑJ
				state_machine.transition( input.c_str() );
			}

			// Ԃ̏񂩂HTML𐶐CPOST̃X|XƂđM
			state = state_machine.getCurrentState().getName();
			next_status.clear();
			disabled_status.clear();
			const vector< StateMachine::State::transition_t > 
				&trans_tbl = state_machine.getCurrentState().getTransitionTable();
			vector< StateMachine::State::transition_t >::const_iterator cit;
			for( cit = trans_tbl.cbegin(); cit != trans_tbl.cend(); ++ cit ) {
				next_status.push_back( cit->next->getName() );
				disabled_status.push_back( cit->on_manual );
			}

			httpc.setHTMLParameter( state, next_status, disabled_status );
			httpc.postDataUpdated();
		}
		if( state_count == 100 ) {
			int idx = state_machine.getRequiredInput( string("AGV outward"), input );
			if( idx == -1 )
				input = "";
			
			// Ԃɂinput̗L
			if( idx != -1 ) {
				disabled_status.at(idx) = false;
				httpc.setHTMLParameter( state, next_status, disabled_status );
				httpc.push();
			}
			state_count = 0;
		}
		Sleep( 50 );

		state_count ++;
	}

	httpc.finalize();
	state_machine.finalize();

	return EXIT_SUCCESS;
}