#include "state-machine.h"
#include <iostream>


using namespace state_machine;
using namespace std;


/**********************************************************
	StateMachine::StateMachine
===========================================================
	ftHgRXgN^
**********************************************************/
StateMachine::StateMachine()
{}


/**********************************************************
	fXgN^
**********************************************************/
StateMachine::~StateMachine()
{
	finalize();
}


/**********************************************************
	(XML̃[h)
**********************************************************/
int StateMachine::initialize( const char *scenario_path )
{
	if( scn_mgr.initialize( scenario_path, state_tbl ) )
		return sys::returnByError< int >( -1,
			"StateMachine::initialize(): cannot load scenario." );

	cs.initialize();

	// ԂփZbg
	curr = &state_tbl.at(0);

	return 0;
}


/**********************************************************
	I
**********************************************************/
int StateMachine::finalize()
{
	scn_mgr.finalize();
	state_tbl.clear();
	cs.finalize();
	return 0;
}


/**********************************************************
	\
**********************************************************/
void StateMachine::print()
{
	scn_mgr.print();
	for( size_t i = 0; i < state_tbl.size(); ++ i )
		state_tbl.at(i).print();
}


/**********************************************************
	ԑJ
**********************************************************/
int StateMachine::isNextStateFound( const char *input )
{
	cout << ">> StateMachine::isNextStateFound(" << input << ")@" << curr->getName() << endl;
	// input vJڂT
	const vector< State::transition_t > &trans_tbl = curr->getTransitionTable();
	int idx, n = (int) trans_tbl.size();
	for( idx = 0; idx < n; ++ idx ) {
		cout << "\ttrans_tbl[" << idx <<"].input: " << trans_tbl.at(idx).input << endl;
		if( trans_tbl.at(idx).input == input ) {
			cout << "<< StateMachine::isNextStateFound(" << input << ")@" << curr->getName() << endl;
			return idx;
		}
	}
	cout << "<< StateMachine::isNextStateFound(" << input << ")@" << curr->getName() << endl;
	return -1;
}


int StateMachine::transition( const char *input )
{
	string output;
	return transition( input, output );
}


int StateMachine::transition( const char *input, std::string &output )
{
	cout << ">> StateMachine::transition(" << input << ")" << endl;

	// input vJڂT
	int idx = isNextStateFound( input );
	if( idx == -1 && (idx = isNextStateFound( "" )) == -1 ) {
		cout << "<< StateMachine::transition(" << input << ") with -1" << endl;	
		return -1;
			// S͂󗝂ԑJڂȂȂI
	}

	cout << "[" << idx << "]" << endl;

	const State::transition_t &trans = curr->getTransitionTable().at(idx);

	cout << curr->getName() << " \[" << input << "/" << trans.output << "] " << trans.next->getName() << endl;

	output = trans.output;
	curr = trans.next;

	cout << "<< StateMachine::transition(" << input << ") with 0" << endl;
	return 0;
}


int StateMachine::setCurrentState( int id )
{
	// IDvԂT
	size_t idx;
	for( idx = 0; idx < state_tbl.size(); ++ idx ) {
		if( state_tbl.at(idx).getID() == id ) {
			curr = &state_tbl.at(idx);
			cs.exit();
			return 0;
		}
	}
	return -1;
}


int StateMachine::setCurrentState( const char *name )
{
	// OvԂT
	size_t idx;
	for( idx = 0; idx < state_tbl.size(); ++ idx ) {
		if( state_tbl.at(idx).getName() == name ) {
			curr = &state_tbl.at(idx);
			return 0;
		}
	}
	return -1;
}



int StateMachine::getError( std::string &error_state_name ) const
{ 
	if( curr->getError() ) {
		error_state_name = curr->getError()->getName();
		return 0;
	}
	
	error_state_name = curr->getName();
	return -1;
}


int StateMachine::transitionIntoError() 
{
	string error_state_name;
	getError( error_state_name );
	setCurrentState( error_state_name.c_str() );
	return 0;
}