#pragma once


#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <iostream>
#include "../VSCommon/system/cmdexec/cmdexec.h"

namespace rtcutil
{

	/*********************************************************
		|[gmF
	*********************************************************/
	template < typename T >
	static bool isInOperation( RTC::CorbaConsumer<T> &svc_port )
	{
		return !CORBA::is_nil( svc_port.getObject() );
	}

	template < typename T >
	static bool write( RTC::OutPort< T > &port )
	{
		bool rc = 0;
		rc = port.write();
		if( !rc ) {
			DataPortStatusList stat = port.getStatusList();
			for( size_t i = 0, len = stat.size(); i < len; ++i ) {
				if( stat[i] != RTC::DataPortStatus::PORT_OK )
					std::cerr << "Port[" << i << "]: write(): failed." << std::endl;
			}
		}
		return rc;
	}



	/********************************************************
		rtshells[eBeBNX
	********************************************************/
	class RTShell
	{
	public:
		// l[T[oXg
		std::string nameservers;

		std::string cmd_line;
		sys::CommandExecutor cmd;

	public: // RXgN^&fXgN^
		RTShell() {}
		~RTShell() {}

	public:
		/*-------------------------------------------------------
			rtact
		-------------------------------------------------------*/
		bool act( const char *rtc_path )
		{
			setNameServers();
			cmd_line += "rtact ";
			cmd_line += rtc_path;

			return execute();
		}
		/*-------------------------------------------------------
			rtexit
		-------------------------------------------------------*/
		bool exit( const char *rtc_path )
		{
			setNameServers();
			cmd_line += "rtexit ";
			cmd_line += rtc_path;

			return execute();
		}

	private:
		/*-------------------------------------------------------
			ϐRTTREE_NAMESERVERS̐ݒ
		-------------------------------------------------------*/
		void setNameServers()
		{
			cmd_line.clear();
			cmd_line = "set RTTREE_NAMESERVERS=";
			cmd_line += nameservers;
			cmd_line += " && ";
		}


		/*-------------------------------------------------------
			R}hC̎sƌʂ̃`FbN
		-------------------------------------------------------*/
		bool execute()
		{

			std::cout << "rtshell$ " << cmd_line << std::endl;
			if( cmd.execute( cmd_line.c_str() ) && !cmd.getResult().length() )
				return true;
			
			std::cout << cmd.getResult() << std::endl;
	
			// cmd.execute() sꍇG[
			// ʕ񂪋AĂꍇG[ȉꍇRTC|[gȂꍇj
			return false;
		}

	public:
		/*-------------------------------------------------------
			rtshell̃R}hs̑ΏۂɂȂl[T[rX̐ݒ
		-------------------------------------------------------*/
		void setNameServers( const std::string &_nameservers )
		{
			nameservers = _nameservers;
		}
		void setNameServers( const std::vector< std::string > &_nameservers )
		{
			nameservers.clear();
			for( std::vector< std::string >::const_iterator cit = _nameservers.begin();
				cit != _nameservers.end(); ++ cit )
			{
				nameservers += *cit;
				nameservers += ";";
			}
		}

	};

}